'From Squeak3.2gamma of 15 January 2002 [latest update: #4811] on 30 April 2002 at 1:04:11 pm'!
Object subclass: #HVHtmlBuilder
	instanceVariableNames: 'request view isPost fields elements variables forms elementStack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlBuilder commentStamp: '<historical>' prior: 0!
HVHtmlBuilder builds HTML pages and handles HTML Forms. It has a reference to the HVHttpView that created it (for various services) and to the request of that view.

Typical use is to instantiate it (HVHttpView has a method #builder which creates one), feed it "build messages" and then finally calling #render which will stream out the resulting HTML page. This is an example:

builder _ self builder.
builder start; h1: 'A heading'; postForm; inputText: #name; submit; endForm; end.
builder render

During the build some of the "build messages" return objects that can be used for input and output - typically objects representing Forms, Inputfields, Submit buttons etc. The messages #postForm, #inputText: and #submit all returned objects in the code above but the code chose to ignore them.

The contents message causes the builder to assemble the finished HTML document and return it as a String, but normally you just return the builder itself since HVHtmlBuilder also implements #asHttpResponseTo: which means that it can be returned as a result to Comanche from an 'url' method in a HVHttpView class. So you do not need to call #render and actually, in order to compose pages from multiple methods it is better if you do not call #render.

...

elements - An OrderedCollection holding all elements that constitute the page.
elementStack - An OrderedCollection acting as a stack for certain elements like for example forms.

!

HVHtmlBuilder class
	instanceVariableNames: ''!
Object subclass: #HVHtmlElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
Object subclass: #HVHtmlEndtag
	instanceVariableNames: 'element '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlEndtag class
	instanceVariableNames: ''!
HVHtmlElement subclass: #HVHtmlForm
	instanceVariableNames: 'name action method elements '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlForm class
	instanceVariableNames: ''!
HVHtmlElement subclass: #HVHtmlVariable
	instanceVariableNames: 'value name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlVariable subclass: #HVHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlInput subclass: #HVHtmlInputCheckbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlInput subclass: #HVHtmlInputHidden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlInput subclass: #HVHtmlInputText
	instanceVariableNames: 'size '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlInputText subclass: #HVHtmlInputNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlInputText subclass: #HVHtmlInputPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlVariable subclass: #HVHtmlSelect
	instanceVariableNames: 'size objects useIds realValues '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlVariable subclass: #HVHtmlTextArea
	instanceVariableNames: 'rows cols '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
HVHtmlVariable class
	instanceVariableNames: ''!
HVHtmlInputText class
	instanceVariableNames: ''!
Object subclass: #HVHttpView
	instanceVariableNames: 'prefix parent title model req '
	classVariableNames: 'HtmlEntities '
	poolDictionaries: ''
	category: 'HV-base'!

!HVHttpView commentStamp: '<historical>' prior: 0!
A VHHttpView is a user interface 'application model' for a web interface (forms etc).

A view has a domain object as a model, and thus the VHHttpView hierarchy more or less typically mirrors the domain class hierarchy. It also has a reference to it's parent view which can be a HVModule if the view is the "top view".

A view is instantiated for every request which means that it does not have to care about multiple
Processes - but since the model can be shared with other views either the model needs to care or
the views needs to serialize their access to the model.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url the framework will call the method with the same name. These methods are kept by convention in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something that Comanche can make HTML from, typically an object implementing #asHttpResponseTo:. String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at HVTodoListView for an example.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

HVHttpView class
	instanceVariableNames: ''!
Object subclass: #HVModule
	instanceVariableNames: 'model prefix '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVModule commentStamp: '<historical>' prior: 0!
This is the Comanche module for the HttpView framework. It holds onto the top domain object
for the webapplication in the instvar 'model'.

Use these doits to start and stop an application (example from SqueakDot):

"Create the top domain object for your application once and for all"
Smalltalk at: #SqueakDot put: SDServer new

"Start up the service"
| service smodule |
service := ComancheNetService named: 'SqueakDot' onPort: 8080.
service module: (smodule _ HttpSessionModule module: (SDModule on: SqueakDot prefix: '/squeakdot')).
SqueakDot module: smodule. "this is a hack to that the SDServer can get access to the sessions"
service start

"And to stop it"
(ComancheNetService serviceNamed: 'SqueakDot') unregister

"Check which services are alive"
ComancheNetService services!

HVModule class
	instanceVariableNames: ''!
HVHtmlVariable subclass: #HVSimpleVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!
Object subclass: #HVTodoList
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample'!

!HVTodoList commentStamp: '<historical>' prior: 0!
This is a very simple domain object for a todolist. I only have an OrderedCollection holding the items and
a few simple methods for adding and removing items from the collection.!

HVTodoList class
	instanceVariableNames: ''!
HVModule subclass: #HVTodoListModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample'!

!HVTodoListModule commentStamp: '<historical>' prior: 0!
This is the Comanche module for the todolist application.
It holds onto the HVTodoList in the instvar 'model' and implements a single method for view creation.

Use these doits to start and stop the application:

"Create the top domain object for your application once and for all"
Smalltalk at: #TodoList put: HVTodoList new

"Start up the service"
(ComancheNetService named: 'TodoList' onPort: 8888) module: (HVTodoListModule on: TodoList prefix: '/todo'); start

"And to stop it"
(ComancheNetService serviceNamed: 'TodoList') unregister

"Check which services are alive"
ComancheNetService services!

HVHttpView subclass: #HVTodoListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample'!

!HVTodoListView commentStamp: '<historical>' prior: 0!
This is the view on the HVTodoList. 

It implements a trivial initialize method in order to set the prefix. It then implements two urls:

- The default page which shows the todolist and has a form for adding items and links for removing items.
- The removeitem page which is the method called when a remove link is clicked. It redirects back to the default page.!


!HVHtmlBuilder methodsFor: 'html-headings' stamp: 'gh 4/30/2002 09:39'!
green: text
	text class == String ifTrue:[^elements add:'<font color="green">', text, '</font>'].
	elements add: '<font color="green">'.
	text value: self.
	elements add: '</font>'! !

!HVHtmlBuilder methodsFor: 'html-headings' stamp: 'gh 2/1/2002 12:58'!
h1: text
	text class == String ifTrue:[^elements add: '<h1>', text, '</h1>'].
	elements add: '<h1>'.
	text value: self.
	elements add: '</h1>'! !

!HVHtmlBuilder methodsFor: 'html-headings' stamp: 'gh 2/1/2002 13:16'!
h2: text
	text class == String ifTrue:[^elements add: '<h2>', text, '</h2>'].
	elements add: '<h2>'.
	text numArgs = 0
		ifTrue:[ text value ]
		ifFalse:[ text value: self].
	elements add: '</h2>'! !

!HVHtmlBuilder methodsFor: 'html-headings' stamp: 'gh 2/1/2002 12:58'!
h3: text
	text class == String ifTrue:[^elements add: '<h3>', text, '</h3>'].
	elements add: '<h3>'.
	text value: self.
	elements add: '</h3>'! !

!HVHtmlBuilder methodsFor: 'html-headings' stamp: 'gh 4/24/2002 14:20'!
red: text
	text class == String ifTrue:[^elements add:'<font color="red">', text, '</font>'].
	elements add: '<font color="red">'.
	text value: self.
	elements add: '</font>'! !

!HVHtmlBuilder methodsFor: 'html-headings' stamp: 'gh 2/4/2002 16:44'!
title: text
	text class == String ifTrue:[^elements add: '<title>', text, '</title>'].
	elements add: '<title>'.
	text value: self.
	elements add: '</title>'! !

!HVHtmlBuilder methodsFor: 'conditionals' stamp: 'gh 2/1/2002 13:22'!
ifPost: aBlock
	^request isPostRequest ifTrue:[aBlock value]! !

!HVHtmlBuilder methodsFor: 'conditionals' stamp: 'gh 2/5/2002 09:36'!
ifSubmit: aBlock
	"If it is a POST or a GET with fields we run the block."

	request isPostRequest ifTrue:[^aBlock value].
	request isGetRequest ifTrue:[request getFields isEmpty ifFalse:[^aBlock value]]! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/15/2002 21:08'!
addForm: aForm
	"Add the form both to the stack
	and to the list of elements."

	elementStack addLast: aForm.
	^elements add: aForm

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/22/2002 13:21'!
addHtmlInput: aVar
	"Add the input variable in the correct Form and
	also add it to the collection of elements."

	self currentForm add: aVar.
	^elements add: aVar

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:52'!
currentForm
	"Find current form by looking in the stack.
	We could probably cache currentForm..."

	elementStack reverseDo: [:e | e isForm ifTrue:[^e]].
	^nil

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:52'!
endForm
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/22/2002 13:10'!
getForm
	^self addForm: (HVHtmlForm getAction: request url)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:08'!
inputCheckbox

	^self inputCheckbox: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:07'!
inputCheckbox: name

	^self inputCheckbox: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 4/30/2002 09:37'!
inputCheckbox: var value: default

	| val |
	val _ default.
	self ifSubmit: [
		val _ (fields includesKey: var)
			ifTrue:[ (fields at: var) = 'on' ]
			ifFalse: [ false ]].
	^self addHtmlInput: (HVHtmlInputCheckbox name: var value: val)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 4/24/2002 15:21'!
inputCheckboxValue: default

	^self inputCheckbox: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 16:00'!
inputHidden

	^self inputHidden: self nextVarName value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 15:59'!
inputHidden: name

	^self inputHidden: name value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 00:29'!
inputHidden: var value: default 

	^self addHtmlInput: (HVHtmlInputHidden name: var value: (fields at: var ifAbsent:[default]))

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 15:59'!
inputNumber

	^self inputNumber: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:00'!
inputNumber: name

	^self inputNumber: name value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:02'!
inputNumber: name size: size

	^self inputNumber: name size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 4/3/2002 13:19'!
inputNumber: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputNumber name: name value: (fields at: name ifAbsent:[default ifNil: [0]]) size: size)

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:00'!
inputNumber: name value: value

	^self inputNumber: name size: 20 value: value

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:05'!
inputNumberSize: size

	^self inputNumber: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:06'!
inputNumberSize: size value: default

	^self inputNumber: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 4/3/2002 13:17'!
inputNumberValue: default

	^self inputNumber: self nextVarName size: 20 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 00:12'!
inputPassword

	^self inputPassword: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name

	^self inputPassword: name value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name size: size

	^self inputPassword: name size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPassword: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputPassword name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:02'!
inputPassword: name value: default

	^self inputPassword: name size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPasswordSize: size

	^self inputPassword: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 00:10'!
inputText

	^self inputText: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/31/2002 15:55'!
inputText: var

	^self inputText: var value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/5/2002 09:20'!
inputText: var size: size

	^self inputText: var size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/22/2002 13:58'!
inputText: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputText name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:37'!
inputText: var value: default

	^self inputText: var size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:00'!
inputTextSize: size

	^self inputText: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'JO 3/4/2002 14:13'!
inputTextSize: size value: default

	^self inputText: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/21/2002 15:58'!
inputTextValue: default

	^self inputText: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/15/2002 16:28'!
postForm
	^self addForm: (HVHtmlForm postAction: request url)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
reset

	^self reset: 'Reset'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/31/2002 15:56'!
reset: text

	^elements add: '<input type="reset" value="', text, '">'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
submit

	^self submit: 'Submit'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/5/2002 09:03'!
submit: text

	^self submit: text value: text
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:07'!
textArea

	^self textArea: self nextVarName rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:07'!
textArea: name

	^self textArea: name rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:32'!
textArea: var rows: rows cols: cols

	^self textArea: var rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:32'!
textArea: var value: default

	^self textArea: var rows: 4 cols: 20 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:06'!
textAreaRows: rows cols: cols

	^self textArea: self nextVarName rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 2/15/2002 14:39'!
addVar: aVar
	"Add the variable in the correct Form and
	add it to the collection of elements."

	self currentForm add: aVar.
	^elements add: aVar

! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 1/15/2002 16:30'!
endTag
	"We assume that the last element on the stack is the correct one."

	^elements add: (HVHtmlEndtag for: elementStack removeLast)! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'JO 3/4/2002 14:07'!
nextVarName
	^self currentForm nextVarName
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 3/15/2002 21:35'!
var
	"Return a variable node. The name will be a single number.
	A variable node can be given content using #value:
	later on after the page has been built but before it is rendered."

	^self var: (variables size fullPrintString) value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 2/22/2002 13:07'!
var: aName
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	^self var: aName value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 3/15/2002 21:32'!
var: aName value: aValue
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	| var |
	var _ HVSimpleVariable name: aName value: aValue.
	variables at: aName put: var.
	^elements add: var

! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 14:42'!
getLink: url text: text
	"Create a HTML link."

	^'<a href="', url, '">', text, '</a>'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 14:43'!
getLinkLocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self getLink: view prefix, relativeUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 1/31/2002 15:56'!
link: url text: text
	"Embed a HTML link."

	^elements add: '<a href="', url, '">', text, '</a>'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/1/2002 13:15'!
linkBack
	"Return a local backlink."

	^self linkBack: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 1/31/2002 15:56'!
linkBack: text
	"Return a local backlink."

	^self link: view prefix text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 3/21/2002 16:02'!
linkBackParent
	"Return a parent backlink."

	^self link: view parent prefix text: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 14:20'!
linkBackParent: text
	"Return a parent backlink."

	^self link: view parent prefix text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/12/2002 11:12'!
linkLocal: relativeUrl text: text
	"Make a local HTML link to the view."

	^self link: view prefix, relativeUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/5/2002 08:43'!
linkPrefix: prefix text: text
	"Embed a link to the view with that prefix."

	| target |
	target _ view.
	[target prefix = prefix ifTrue:[ ^self link: target prefix text: text ].
	target _ target parent.
	target notNil] whileTrue.
	^self link: prefix text: 'No view found for this link'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 15:13'!
srcLink
	| url slash |
	(request url = view prefix)
		ifTrue:[ url _ request url, '/srcdefault' ]
		ifFalse:[	slash _ request url findLast: [:c | c = $/ ].
			url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size)].
	^self html: '<font size=-1>'; link: url text: 'See source for this page'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/8/2002 15:59'!
br
	^elements add: '<br />'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:43'!
end
	^elements add: '</body></html>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/8/2002 15:59'!
hr
	^elements add: '<hr />'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:47'!
html: aString
	^elements add: aString! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 3/20/2002 18:08'!
nbsp
	^elements add: '&nbsp;'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ol: items
	"Make an ordered list by using asString on the elements."
	
	^self ol: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/12/2002 11:07'!
ol: items do: aBlock
	"Make an ordered list but we let the block
	add the item to the builder itself."
	
	elements add: '<ol>'.
	items do: [:i |
		elements add: '<li>'.
		aBlock value: i.
		elements add: '</li>' ].
	elements add: '</ol>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/12/2002 11:09'!
ol: items extract: aBlock
	"Make an ordered list with the value of the block
	as the item, use #ol:do: for fancier stuff."
	
	elements add: '<ol>'.
	items do: [:i | elements add: '<li>', (aBlock value: i), '</li>' ].
	elements add: '</ol>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/8/2002 15:59'!
p: text
	text class == String ifTrue:[^elements add: '<p>', text, '</p>'].
	elements add: '<p>'.
	text value: self.
	elements add: '</p>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 3/21/2002 14:44'!
pre: text
	text class == String ifTrue:[^elements add: '<pre>', text, '</pre>'].
	elements add: '<pre>'.
	text value: self.
	elements add: '</pre>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/22/2002 13:28'!
start
	elements add: '<html><head>'.
	self var: #head value: '<title>', view title, '</title>'.
	elements add: '</head>'.
	self var: #bodytag value: '<body>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/1/2002 11:18'!
table: objects heads: heads block: aBlock
	"Add a table."

	^self html: (String streamContents: [:stream |
		stream nextPutAll: '<table border="1"><head>'.
		heads do: [:head | stream nextPutAll: '<th>'; nextPutAll: head; nextPutAll: '</th>'].
		stream nextPutAll: '</head>'.
		objects do: [:obj |
			stream nextPutAll: '<tr>'.
			(aBlock value: obj) do: [:val | stream nextPutAll: '<td>'; nextPutAll: val asString; nextPutAll: '</td>' ].
			stream 	nextPutAll: '</tr>'.
		].
		stream nextPutAll: '</table>' ])
! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/1/2002 12:59'!
tag: tag around: text
	text class == String ifTrue:[^elements add: '<',tag,'>', text, '<',tag,'>'].
	elements add: '<',tag,'>'.
	text value: self.
	elements add: '<',tag,'>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ul: items
	"Make an unordered list by using asString on the elements."
	
	^self ul: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:10'!
ul: items do: aBlock
	"Make an unordered list but we let the block
	add the item to the builder itself."

	elements add: '<ul>'.
	items do: [:i |
		elements add: '<li>'.
		aBlock value: i.
		elements add: '</li>' ].
	elements add: '</ul>'! !

!HVHtmlBuilder methodsFor: 'initialize-release' stamp: 'gh 3/15/2002 20:57'!
request: aRequest view: aView

	view _ aView.
	request _ aRequest.
	isPost _ request isPostRequest.
	isPost ifTrue: [fields _ request postFields] ifFalse: [fields _ request getFields].
	elements _ OrderedCollection new.
	elementStack _ OrderedCollection new.
	variables _ Dictionary new! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/15/2002 14:11'!
asString
	^self render! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/5/2002 15:15'!
at: var ifAbsent: block

	^fields at: var ifAbsent: [^block value]! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/5/2002 14:09'!
booleanAt: var ifAbsent: block

	^(fields at: var ifAbsent: [^block value]) = 'on'! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/5/2002 15:14'!
numberAt: var ifAbsent: block

	^(fields at: var ifAbsent: [^block value]) asNumber! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 15:43'!
render
	"Concatenate everything together and substituting variables
	in the progress. First we check if we are timing this page.
	If we are then we need to calculate the stop time and incorporate
	the time at the bottom of the page."

	| start result |
	start _ request propertyAt: #startTime ifAbsent: [nil].
	start ifNotNil: [elements removeLast ].
	result _ String streamContents: [:stream |
			elements do: [:element |
				element class == String
					ifTrue:[ stream nextPutAll: element ]
					ifFalse:[ element renderOn: stream ]]].
	start ifNotNil: [^result, '<br><font size=-1>Time in ms: ', (Time millisecondClockValue - start) asString, '</font></body></html>', String crlf].
	^result, '</body></html>', String crlf

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 11:33'!
select: aName objects: objects useIds: useIds realValues: realValues size: size value: default

	| val |
	realValues
		ifTrue: [
			useIds
				ifTrue:[ val _ default id asString ]
				ifFalse: [ val _ (objects indexOf: default) asString]]
		ifFalse: [val _ default asString].
	^self addHtmlInput: (HVHtmlSelect name: aName objects: objects useIds: useIds realValues: realValues size: size value: (fields at: aName ifAbsent:[val]))
! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 10:33'!
select: aName objects: objects value: default

	^self select: aName objects: objects useIds: true realValues: true size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 15:03'!
selectObjects: objects

	^self select: self nextVarName objects: objects useIds: false realValues: true size: 1 value: (objects isEmpty ifTrue: [nil] ifFalse: [objects first])! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 11:01'!
selectObjects: objects useIds: useIds

	^self select: self nextVarName
		objects: objects
		useIds: useIds
		realValues: true
		size: 1
		value: objects first

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 10:34'!
selectObjects: objects useIds: useIds realValues: real value: default

	^self select: self nextVarName objects: objects useIds: useIds realValues: real size: 1 value: default

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 10:33'!
selectObjects: objects useIds: useIds value: default

	^self select: self nextVarName objects: objects useIds: useIds realValues: true size: 1 value: default

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 4/3/2002 10:34'!
selectObjects: objects value: default

	^self select: self nextVarName objects: objects useIds: false realValues: true size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/5/2002 09:55'!
submitted: aString

	fields at: aString ifAbsent: [^false].
	^true! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 3/19/2002 21:01'!
textArea: name rows: rows cols: cols value: default

	^self addHtmlInput: (HVHtmlTextArea name: name rows: rows cols: cols value: (fields at: name ifAbsent:[default]))
! !

!HVHtmlBuilder methodsFor: 'composition' stamp: 'gh 2/4/2002 16:45'!
head
	"Create and return a subbuilder for the head of the document.
	This is a variable reserved automatically in #start."

	| child |
	self var: #head value: (child _ HVHtmlBuilder request: request view: view).
	child title: view title.
	^child! !

!HVHtmlBuilder methodsFor: 'composition' stamp: 'gh 2/5/2002 10:02'!
submit: var value: default

	| value |
	value _ fields includesKey: var.
	elements add: '<input type="submit" name="', var, '" value="', default, '">'.
	^value
! !

!HVHtmlBuilder methodsFor: 'comanche' stamp: 'gh 2/15/2002 14:11'!
asHttpResponseTo: req
	"We implement this so that a builder can be returned as a
	result from a method rather than a HTML String.
	This also enables nestling of builders in order to compose
	pages by calling other 'submethods'."

	^HttpResponse fromString: self render! !


!HVHtmlBuilder class methodsFor: 'instance creation' stamp: 'gh 1/31/2002 14:41'!
request: aRequest view: aView
	^self new request: aRequest view: aView; yourself! !


!HVHtmlElement methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^false! !

!HVHtmlElement methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:34'!
render

	^String streamContents: [:stream | self renderOn: stream ]! !


!HVHtmlEndtag methodsFor: 'accessing' stamp: 'gh 2/15/2002 14:34'!
element: anElement
	element _ anElement! !

!HVHtmlEndtag methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:31'!
renderOn: stream
	"We ask the element that we are the endmarker for
	to render it's 'end' on the stream."

	element renderEndOn: stream! !


!HVHtmlEndtag class methodsFor: 'instance creation' stamp: 'gh 2/15/2002 14:34'!
for: element
	^self new element: element; yourself! !


!HVHtmlForm methodsFor: 'testing' stamp: 'gh 4/3/2002 14:13'!
ifSubmit: aBlock
	0 halt.! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^true! !

!HVHtmlForm methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:29'!
renderEndOn: stream

	stream nextPutAll: '</form>'! !

!HVHtmlForm methodsFor: 'rendering' stamp: 'gh 2/15/2002 14:47'!
renderOn: stream

	stream
		nextPutAll: '<form action="';
		nextPutAll: action;
		nextPutAll: '" method="', method, '">'! !

!HVHtmlForm methodsFor: 'initialize-release' stamp: 'gh 2/22/2002 13:26'!
action: anAction method: aMethod name: aName

	action _ anAction.
	method _ aMethod.
	name _ aName.
	elements _ OrderedCollection new! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gh 2/22/2002 13:27'!
add: anHtmlElement
	^elements add: anHtmlElement! !

!HVHtmlForm methodsFor: 'elements' stamp: 'JO 3/4/2002 14:07'!
nextVarName
	^elements size fullPrintString asSymbol! !


!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gh 2/15/2002 14:53'!
getAction: action

	^self new action: action method: 'get' name: nil! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gh 2/15/2002 14:49'!
postAction: action

	^self new action: action method: 'post' name: nil! !


!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
name
	^name! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:54'!
name: aName
	name _ aName! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value
	^value! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value: aVal
	value _ aVal! !

!HVHtmlVariable methodsFor: 'initialize-release' stamp: 'gh 2/15/2002 13:55'!
initialize
	! !

!HVHtmlVariable methodsFor: 'rendering' stamp: 'gh 2/15/2002 14:18'!
render

	^String streamContents: [:stream | self renderOn: stream ]! !

!HVHtmlVariable methodsFor: 'rendering' stamp: 'gh 2/22/2002 14:26'!
renderOn: stream
	"My subclasses should implement this."

	self subclassResponsibility ! !

!HVHtmlVariable methodsFor: 'private' stamp: 'gh 2/22/2002 12:44'!
name: aName value: aValue
	name _ aName.
	value _ aValue! !


!HVHtmlInput methodsFor: 'rendering' stamp: 'gh 3/16/2002 00:32'!
renderAttributesOn: stream
	"Default implementation does nothing."
! !

!HVHtmlInput methodsFor: 'rendering' stamp: 'gh 2/22/2002 13:59'!
renderOn: stream

	stream nextPutAll: '<input type="', self renderType, '" name="', name, '"'.
	self renderAttributesOn: stream.
	self renderValueOn: stream.
	stream nextPutAll: '>'! !

!HVHtmlInput methodsFor: 'rendering' stamp: 'gh 4/3/2002 13:20'!
renderValueOn: stream

	stream nextPutAll: ' value="', value asString, '"'.! !


!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType
	^'checkbox'! !

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gh 2/22/2002 14:00'!
renderValueOn: stream
	value ifTrue:[stream nextPutAll: ' checked']! !


!HVHtmlInputHidden methodsFor: 'as yet unclassified' stamp: 'gh 3/16/2002 00:27'!
renderType

	^'hidden'! !


!HVHtmlInputText methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:40'!
renderAttributesOn: stream

	stream nextPutAll: ' size="', size fullPrintString, '"'! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType

	^'text'! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size
	^size! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size: aSize
	size _ aSize! !


!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value
	^super value asNumber! !

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value: aValue
	^super value: aValue fullPrintString! !


!HVHtmlInputPassword methodsFor: 'rendering' stamp: 'gh 3/4/2002 17:37'!
renderType

	^'password'! !


!HVHtmlSelect methodsFor: 'rendering' stamp: 'gh 4/3/2002 11:36'!
renderOn: stream

	| obj id val |
	useIds ifTrue:[ val _ VHTumbler fromString: value ] ifFalse:[ val _ value asInteger].
	stream nextPutAll: '<select name="', name, '" size="', size printString ,'">'.
	1 to: objects size do: [:n |
		obj _ objects at: n.
		useIds ifTrue:[ id _ obj id] ifFalse:[ id _ n].
		(id = val)
			ifTrue: [stream nextPutAll: '<option selected']
			ifFalse: [stream nextPutAll: '<option' ].
		stream nextPutAll: ' value="', id fullPrintString, '">'.
		stream nextPutAll: obj asString.
		stream nextPutAll: '</option>'.
	].
	stream nextPutAll: '</select>'! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
objects
	^objects! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 4/3/2002 11:20'!
objects: objs useIds: use realValues: real size: s
	objects _ objs. useIds _ use. realValues _ real. size _ s! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 4/3/2002 10:35'!
realValues
	^realValues! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:55'!
size
	^size! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
size: aSize
	size _ aSize! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
useIds
	^useIds! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 4/23/2002 13:16'!
value
	| tumbler |
	realValues
		ifTrue: [
			useIds
				ifTrue:[
					tumbler _ VHTumbler fromString: value.
					^objects detect: [:obj | obj id = tumbler] ]
				ifFalse: [ ^objects at: value asInteger ifAbsent: [nil]]]
		ifFalse: [^value]! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 4/3/2002 11:18'!
value: aValue
	realValues
		ifTrue: [
			useIds
				ifTrue:[ value _ aValue id asString ]
				ifFalse: [ value _ (objects indexOf: aValue) asString]]
		ifFalse: [value _ aValue asString]! !


!HVHtmlTextArea methodsFor: 'rendering' stamp: 'gh 3/19/2002 20:58'!
renderOn: stream

	stream
		nextPutAll: '<textarea name="', name, '" rows="', rows asString, '" cols="', cols asString, '">';
		nextPutAll: value; nextPutAll: '</textarea>'
! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:01'!
cols
	^cols! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:00'!
rows
	^rows! !

!HVHtmlTextArea methodsFor: 'private' stamp: 'gh 3/19/2002 21:00'!
rows: r cols: c
	rows _ r.
	cols _ c! !


!HVHtmlVariable class methodsFor: 'instance creation' stamp: 'gh 2/22/2002 12:44'!
name: aName value: aValue
	^super new name: aName value: aValue; yourself! !

!HVHtmlVariable class methodsFor: 'instance creation' stamp: 'gh 2/15/2002 13:55'!
named: aName
	^super new initialize; name: aName; yourself! !


!HVHtmlInputText class methodsFor: 'instance creation' stamp: 'gh 2/22/2002 13:15'!
name: aName value: aValue size: aSize
	^super new name: aName value: aValue; size: aSize; yourself! !


!HVHtmlSelect class methodsFor: 'instance creation' stamp: 'gh 4/3/2002 10:31'!
name: aName objects: objects useIds: useIds realValues: realValues size: size value: aValue
	^super new name: aName value: aValue;
		objects: objects useIds: useIds realValues: realValues size: size; yourself! !


!HVHtmlTextArea class methodsFor: 'instance creation' stamp: 'gh 3/19/2002 21:01'!
name: aName rows: rows cols: cols value: aValue
	^super new name: aName value: aValue; rows: rows cols: cols; yourself! !


!HVHttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 14:22'!
message: message
	"Return a single page with a message and a back link to base page of this view."

	^self starthtml, '<h1>', message, '</h1>', (self linkback: 'Back'), self endhtml
! !

!HVHttpView methodsFor: 'simple messages' stamp: 'gh 1/29/2002 16:12'!
message: message backlink: link
	"Return a single page with a message and a hard link back."

	^self starthtml, '<h1>', message, '</h1>', (self linklocal: link text: 'Back'), self endhtml
! !

!HVHttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 13:54'!
message: message link: link
	"Return a single page with a message and a back link relative to this view."

	^self starthtml, '<h1>', message, '</h1>', (self link: link text: 'Back'), self endhtml
! !

!HVHttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 13:55'!
message: message linklocal: link
	"Return a single page with a message and a back link relative to this view."

	^self starthtml, '<h1>', message, '</h1>', (self linklocal: '/', link text: 'Back'), self endhtml
! !

!HVHttpView methodsFor: 'simple messages' stamp: 'gh 1/14/2002 16:53'!
serverError: aString
	"Return an error to the user."

	^'Error returned by server: ', aString! !

!HVHttpView methodsFor: 'urls' stamp: 'gh 2/11/2002 18:33'!
default
	"This is the default method called on a HttpView if no other
	method is named in the url. It is the base page for the view.
	It should always be implemented. This is a simple test implementation."

	| b |
	b _ self builder.
	b start; h1: 'View for model:'; p: model printString; end.
	^b! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 18:00'!
currentAccount
	"Get the account for the request."

	^req session attributes at: #account ifAbsent: [nil]! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:39'!
dispatch
	"Dispatch to correct method in this view."

	^self dispatchOn: (self methodAfter: self prefix)


! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 18:20'!
dispatchOn: method 
	"Dispatch to correct method:
	- If method is empty we call #default:
	- If self responds then we just call it, otherwise:
		- If method is prefixed with 'tms' we strip that (timing) and try again.
	- If method is prefixed with 'src' we return a HTML page with the source for that method."


	| m |
	method isEmpty ifTrue:[ ^self default ].
	m _ method asSymbol.
	[(self respondsTo: m) ifTrue:[^self perform: m].
	(m beginsWith: 'tms')] whileTrue: [m _ (m last: (m size - 3)) asSymbol].
		
	"Is it a request for the source?"
	(m beginsWith: 'src')
		ifTrue:[
			m _ (m asString last: (m size - 3)) asSymbol.
			(m beginsWith: 'tms') ifTrue: [m _ (m last: (m size - 3)) asSymbol].
			^self showSourceFor: m]
		ifFalse:[^self class name, ' does not have a method called #', m]

! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:34'!
isLoggedIn
	"Check if the user is logged in."

	^req session attributes includesKey: #account! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 18:00'!
logout
	"Tell the account that it is being logged out.
	Clear out the account attribute in the session.
	Return true if all succeded."

	self currentAccount logout.
	req session attributes removeKey: #account ifAbsent: [^false].
	^true! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:29'!
methodAfter: aPrefix
	"Extracts the method from the url in the request.
	The methodname is after the prefix upto the first $? $/ or end of url like this:
	'/prefix/method/knirk?habbadubba' => 'method'
	'/prefix/method?habbadubba' => 'method'
	'/prefix/method' => 'method'
	'/prefix/' => ''
	'/prefix' => ''"

	| method endq ends url |
	url _ req url.
	(url = aPrefix) ifTrue:[ ^'' ].
	method _ url copyFrom: aPrefix size + 1 to: url size. "cut away prefix"
	(method = '/') ifTrue:[ ^'' ].
	method _ method allButFirst.
	endq _ method indexOf: $?.
	ends _ method indexOf: $/.
	(endq = 0) ifTrue:[ endq _ method size + 1].
	(ends = 0) ifTrue:[ ends _ method size + 1].
	^method copyFrom: 1 to: (ends min: endq) - 1! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:39'!
methodInUrl: url after: aPrefix
	"Extracts the method from the url.
	The methodname is after the prefix upto the first $? $/ or end of url like this:
	'/prefix/method/knirk?habbadubba' => 'method'
	'/prefix/method?habbadubba' => 'method'
	'/prefix/method' => 'method'
	'/prefix/' => ''
	'/prefix' => ''"

	| method endq ends |
	(url = aPrefix) ifTrue:[ ^'' ].
	method _ url copyFrom: aPrefix size + 1 to: url size. "cut away prefix"
	(method = '/') ifTrue:[ ^'' ].
	method _ method allButFirst.
	endq _ method indexOf: $?.
	ends _ method indexOf: $/.
	(endq = 0) ifTrue:[ endq _ method size + 1].
	(ends = 0) ifTrue:[ ends _ method size + 1].
	^method copyFrom: 1 to: (ends min: endq) - 1! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 13:36'!
prefix
	"Return the full prefix which is composed by concatenating up the parent chain."

	^String streamContents: [:stream | stream nextPutAll: parent prefix; nextPutAll: prefix ]! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 2/12/2002 11:53'!
redirectToDefault
	"Make a redirection to the default url of this view."

	^req redirectTo: self prefix! !

!HVHttpView methodsFor: 'comanche' stamp: 'gh 3/4/2002 16:41'!
redirectToLocal: page
	"Make a redirection to another page in this view."

	^req redirectTo: self prefix, '/', page! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 2/8/2002 12:29'!
initialize
	title _ 'No title set'.
! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 2/4/2002 13:43'!
model
	^model! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:15'!
model: aModel
	model _ aModel! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 2/4/2002 14:23'!
parent
	^parent! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 2/8/2002 16:28'!
request
	^req! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 2/8/2002 16:28'!
request: aRequest
	req _ aRequest! !

!HVHttpView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:58'!
title
	^title! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 2/8/2002 16:39'!
builder
	"Create a standard builder with our own request."

	^HVHtmlBuilder request: req view: self! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/18/2002 12:21'!
createSelectWidget: values name: name 
	"Create a select widget for forms."

	^self createSelectWidget: values selected: 1 name: name! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/18/2002 12:20'!
createSelectWidget: values selected: selected name: name 
	"Create a select widget for forms."

	^self createSelectWidget: values selected: selected name: name withIds: true
! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/18/2002 12:26'!
createSelectWidget: objects selected: selected name: name withIds: withIds
	"Create a select widget for forms."

	| obj id |
	^String streamContents: [:stream |
		stream nextPutAll: '<select name="', name, '" size="1">'.
		1 to: objects size do: [:n |
			obj _ objects at: n.
			withIds ifTrue:[ id _ obj id] ifFalse:[ id _ n].
			(id = selected)
				ifTrue: [ stream nextPutAll: '<option selected']
				ifFalse: [ stream nextPutAll: '<option' ].
			withIds
				ifTrue: [stream nextPutAll: ' value="', id fullPrintString, '">']
				ifFalse: [stream nextPut: $> ].
			stream nextPutAll: obj name; nextPutAll: '</option>'.
		].
		stream nextPutAll: '</select>']
! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/30/2002 15:58'!
endhtml
	"Standard end."

^'</body></html>'! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/30/2002 15:57'!
endhtml: request
	"Standard end. Attach a link to the source of the page."

	| url slash |
	slash _ request url findLast: [:c | c = $/ ].
	url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size).
^'<hr><br><font size=-1>', (self link: url text: 'See source for this page'), '</font></body></html>'! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:32'!
fixForHtml: string
	"Replace a lot of characters with HTML friendly stuff."

	| temp |
	temp _ string copyReplaceAll: '&' with: '&amp;'.
	HtmlEntities keysAndValuesDo:
		[:entity :char |
		char = $& ifFalse:
			[temp _ temp copyReplaceAll: char asString with: '&' , entity , ';']].
	^'<pre>', temp, '</pre>'! !

!HVHttpView methodsFor: 'html creation' stamp: 'JO 3/4/2002 11:28'!
initializeWith: aParent
	"If we have no request set yet, we pick it from our parent."

	parent _ aParent.
	req ifNil: [req _ parent request]. "This has no effect if the parent is a HVModule but then request is set later in #process: instead"
	self initialize! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/28/2002 15:40'!
link: url text: text
	"Return a HTML link."

	^String streamContents: [:stream |
		stream
			nextPutAll: '<a href="';
			nextPutAll: url;
			nextPutAll: '">'; nextPutAll: text; nextPutAll: '</a>' ]
! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:29'!
linkback: text
	"Return a local backlink."

	^self link: self prefix text: text
! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:30'!
linkbackparent: text
	"Return a parent backlink."

	^self link: parent prefix text: text
! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:24'!
linklocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self link: self prefix, relativeUrl text: text
! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 16:13'!
showSourceFor: selector
	"Show the source for given selector."

^self starthtml, '
<h2>Source for ', self class name, '>>', selector, '</h2>
<pre>
', (self fixForHtml: (self class sourceMethodAt: selector) asString), '
</pre>', self endhtml! !

!HVHttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:23'!
starthtml
	"Standard start."

^'<html><head><title>', self title, '</title></head><body>'! !


!HVHttpView class methodsFor: 'instance creation' stamp: 'gh 2/8/2002 12:26'!
on: aModel parent: aParent
	^(self new model: aModel) initializeWith: aParent; yourself! !

!HVHttpView class methodsFor: 'class initialization' stamp: 'gh 2/8/2002 12:26'!
initialize
	"HVHttpView initialize"

HtmlEntities _ (Dictionary new: 128)
		at: 'amp'	put: $&;
		at: 'lt'		put: $<;
		at: 'gt'		put: $>;
		at: 'quot'	put: $";
		at: 'euro'	put: Character euro;
		yourself.
	"#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo: [:each :index | HtmlEntities at: each put: (index + 159) asCharacter isoToSqueak]"! !


!HVModule methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:18'!
model: aModel
	"Set the top domain object for the web application."

	model _ aModel! !

!HVModule methodsFor: 'comanche' stamp: 'gh 2/12/2002 11:02'!
prefix
	"Get the prefix that must match on the url for this module to handle the request."

	^prefix! !

!HVModule methodsFor: 'comanche' stamp: 'gh 2/12/2002 10:55'!
prefix: aPrefix
	"Set the prefix that must match on the url for this module to handle the request."

	prefix _ aPrefix! !

!HVModule methodsFor: 'comanche' stamp: 'gh 2/26/2002 17:39'!
process: request
	"Process the request. This is the method that is called by Comanche.
	We instantiate a view for our model and simply
	sticks the request into him and let him take over."

	| url view |
	url _ request url.
	(url beginsWith: prefix) ifFalse: [^nil].
	(url findString: 'tms') = 0 ifFalse:[ request propertyAt: #startTime put: Time millisecondClockValue ].
	view _ model viewFor: self.
	view request: request. "normally not needed when using #viewFor: but here it is"
	^view dispatch! !

!HVModule methodsFor: 'comanche' stamp: 'gh 2/11/2002 09:11'!
request
	"Sorry, we don't have one."

	^nil! !


!HVModule class methodsFor: 'instance creation' stamp: 'gh 2/12/2002 10:54'!
on: aModel prefix: prefix
	^self new model: aModel; prefix: prefix; yourself! !


!HVSimpleVariable methodsFor: 'rendering' stamp: 'gh 2/22/2002 14:26'!
renderOn: stream
	"My implementation is to just convert the value to a String."

	stream nextPutAll: value asString! !


!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
addItem: item

	^items add: item! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
items

	^items! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
removeItem: item

	^items remove: item! !

!HVTodoList methodsFor: 'initialize-release' stamp: 'gh 2/12/2002 10:36'!
initialize
	items _ OrderedCollection new! !

!HVTodoList methodsFor: 'views' stamp: 'gh 2/12/2002 10:40'!
viewFor: uiObject
	"This is a double dispatch mechanism for multiple views
	for multiple uis."

	^uiObject todoListViewOn: self! !


!HVTodoList class methodsFor: 'instance creation' stamp: 'gh 2/12/2002 10:36'!
new
	^super new initialize! !


!HVTodoListModule methodsFor: 'views' stamp: 'JO 3/4/2002 11:36'!
todoListViewOn: aTodoList
	"Wrap it in a view.
	NOTE: We have no request to set here - it will be inserted
	in #process:. Since we are being called in multiple Processes we can't hold onto
	th request in an instvar."

	^HVTodoListView on: aTodoList parent: self! !


!HVTodoListView methodsFor: 'initialize-release' stamp: 'gh 4/8/2002 18:52'!
default
	"This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'."

	| b item count |
	b _ self builder.
	b start; h1: 'Todo list'.
	count _ 1.
	b ol: model items do: [:i |
		b linkLocal: '/removeitem?id=', count fullPrintString text: 'R'.
		b html: ' ', i.
		count _ count + 1].
	item _ b postForm; html: 'Add item: '; inputTextSize: 40.
	b submit; endForm; hr; srcLink; end.
	b ifSubmit: [
		model addItem: item value.
		^self redirectToDefault
	].
	^b! !

!HVTodoListView methodsFor: 'initialize-release' stamp: 'gh 2/12/2002 11:32'!
initialize
	"We set the title of the view - it will show up as the page title.
	We also set the prefix of this view - in this case it is empty."

	title _ 'Todo'.
	prefix _ ''! !

!HVTodoListView methodsFor: 'initialize-release' stamp: 'gh 2/12/2002 11:53'!
removeitem
	"Remove an item in the todolist. We pick out
	the index from the url."

	| id removeItem |
	id _ (req getFields at: 'id') asNumber.
	removeItem _ model items at: id.
	model removeItem: removeItem.
	^self redirectToDefault! !

HVHttpView initialize!
HVHtmlInputCheckbox removeSelector: #value!
HVHtmlBuilder removeSelector: #ul:block:!
