'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 20 February 2002 at 2:16:43 pm'!
"Change Set:		kom412-base
Date:			20 February 2002
Author:			Bolot Kerimbaev

bolot 2/20/2002 12:47
- Comanche/4.12 (kom/4.12):
-- bug fixes from Goran
-- session support from Diego
-- Bolot's OOPSLA demo code (put arbitrary objects on the web, including Morphs)

bolot 1/02/2002 16:34
- Comanche/4.11 (kom/4.11) was released only internally, as part of ComSwiki 1.2
- on top of kom/4.10 it included two bug fixes:
-- uploads boundary (in rare cases, the data from socket would be read in such a way that the parsing algorithm would get confused, now a more robust parsing algorithm is used)
-- SocketStream>>match:

preamble - bolot 7/4/2001 18:40

Comanche 4.10 beta, base package. kom/4.10 is a service release, primarily for ComSwiki 1.1 and for some minor bug fixes. Additionally, it features a few new beginnings, which are incomplete, but are included as a 'teaser' and will be expanded in kom/4.11 and beyond. Among teasers are: HttpFormDictionary (allows for multiple values for the same field name), ChieftainModule (application dispatcher).

Comanche is an open-source web server for Squeak (http://minnow.cc.gatech.edu/swiki).

To get started, try the following in the workspace:
ChieftainModule basicExample
it will start a server on port 8017, which serves two applications:
http://localhost:8017/displaycam
http://localhost:8017/helloworld

To stop the server, do the following:
| che | (che _ ComancheServer serverOnPort: 8017 ifAbsent: []) ifNotNil: [che stop].
ComancheNetService removeServiceNamed: 'basicExample'.

Comanche contains the server framework, which makes it possible to develop web applications entirely in Squeak, without the need to run an external web server.

Please check Kom-demo for more examples, look in the class comments.

Bug fixes in Kom 4.10:
- get and post field names are now case-sensitive
- on-going work on SocketStream, removed a potential infinite loop (happens under rare circumstances on some platforms)

What's new in Kom 4.10:
- HTML UI builder framework (early alpha)
- Kishi, an application framework
-- bare Comanche is too bare to build large applications, this should make it easier"!

Object subclass: #ChieftainModule
	instanceVariableNames: 'urlMap urlPrefixMap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-Kishi'!

!ChieftainModule commentStamp: '<historical>' prior: 0!
ChieftainModule
bolot 6/21/2001 03:08

- decides which app/module/obj handles a given URL
- urlMap is for mapping a single URL to a single object
-- e.g., cached objects
- urlPrefixMap is for mapping a URL prefix to an application

----
- todo: cached objects
-- timeout
-- duplication (e.g., what if registering same object again?)
- todo: urlPrefix mapping
-- fast determination which module needs to run
- todo: session management
- todo: form processing!

Object subclass: #ComancheServer
	instanceVariableNames: 'connectionHandler serviceProvider '
	classVariableNames: 'Servers '
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ComancheServer commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ComancheServer
!

Object subclass: #ComancheService
	instanceVariableNames: 'autoStart log '
	classVariableNames: 'Services '
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ComancheService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:43

ComancheService

Comment from kom46:
I am an abstract superclass.  My subclasses are services that can be established on any port.
!

ComancheService subclass: #ComancheNetService
	instanceVariableNames: 'comancheServer protocolAdaptor module '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ComancheNetService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ComancheNetService

Comment from kom46:
I'm a service that sets up a ComancheServer to listen on a given port.  I use a protocol adaptor to adapts TCP/IP based protocol conversations into message based conversations.

protocolAdaptor - an object that supports the NetworkProtocolAdaptor class interface (specifically, I send it #processSocket:target:).
comancheServer - an instance of a ComancheServer that handles all the details of setting up to listen for sockets on a given port.
!

Object subclass: #ConnectionHandler
	instanceVariableNames: 'portNumber socketClass process priority handlerBlock lastError socketsToDestroy '
	classVariableNames: 'Registry '
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ConnectionHandler commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ConnectionHandler

Comment from kom46:
- also see ConnectionQueue
- does not keep the queue of open sockets
- launches the applications/modules immediately
  upon accepting a connection!

Object subclass: #DisplayCamModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!DisplayCamModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:53

DisplayCamModule
- formerly, RemoteDisplayModule
-- renamed to make it more specific
-- we're not VNC
- serves a scaled snapshot of the current Display

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'DisplayCamExample' onPort: 8000.
service module: (DisplayCamModule new).
service start
!

Object subclass: #HelloWorldModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!HelloWorldModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:54

HelloWorldModule
- a mandatory example
- just serves a String, which Comanche converts to HttpResponse

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'HelloWorldExample' onPort: 8000.
service module: (HelloWorldModule new).
"alternatively, service module: (SinglePlugModule displayCam)"
service start
!

Object subclass: #HtmlComancheForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!HtmlComancheForm commentStamp: '<historical>' prior: 0!
bolot 10/18/2001 13:53

- convert a form spec into a form
- convert form input into variables

Example
#(  (search String 'Keyword: ')  (submit SubmitButton 'Search')
-->
<form action="<%self url%>" method="get">
Keyword: <input type="search">
<input type="submit" name="submit" value="Search">
</form>
!

Error subclass: #HttpBadRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpBadRequest commentStamp: 'bolot 2/20/2002 13:58' prior: 0!
kom/4.12 (Comanche/4.12)

HttpBadRequest (kom/4.8; bolot 4/2/2001 18:48)
- an error that gets translated to HTTP error code 400!

Dictionary subclass: #HttpFormDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpFormDictionary commentStamp: 'bolot 2/20/2002 13:57' prior: 0!
kom/4.12 (Comanche/4.12)

HttpFormDictionary (kom/4.10; bolot 6/22/2001 12:09)
- use this instead of plain Dictionary for GET and POST forms
- maintains multiple values for the same field
-- but is backwards compatible, #at: returns the first value (?)
-- so do #booleanAt:, #numberAt:
- to access the actual value at key, use #rawAt:
-- returns an OrderedCollection

TODO:
- file upload support
-- idea: first value is file name, second is FileStream?
!

Object subclass: #HttpParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpParser commentStamp: 'bolot 2/20/2002 13:57' prior: 0!
kom/4.12 (Comanche/4.12)

HttpParser (kom/4.10; bolot 6/22/2001 11:59)
- everything is on class side
- all parsing utilities (form fields, forms, headers, etc.)
-- moved out of other Http$$ classes

what's new in kom/4.10
- case-sensitive form fields (case is preserved)
- multiple values for fields
-- through using HttpFormDictionary!

Error subclass: #HttpRedirect
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpRedirect commentStamp: 'bolot 2/20/2002 13:56' prior: 0!
kom/4.12 (Comanche/4.12)

HttpRedirect (bolot 4/2/2001 18:50)
- an error that gets translated to HTTP error code 30x
-- relocate to the given URL!

Object subclass: #HttpResponse
	instanceVariableNames: 'contents contentType status request fields cookies '
	classVariableNames: 'StatusCodes '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpResponse commentStamp: 'bolot 2/20/2002 13:55' prior: 0!
kom/4.12 (Comanche/4.12)
bolot 2/20/2002 13:55
- cookies support
- defaultChunkSize delegates to Kom5Preferences

HttpResponse (bolot 4/2/2001 18:52)

Comment from kom46:
I am a response to an HttpRequest.  I can formulate an HTTP response and send it out over a socket.  An HttpAdapter will accept an HttpRequest, dispatch a method call to an HttpPlug (which will result in a stream or an error), and then formulat an instance of me to deliver the response to the client.!

HttpResponse subclass: #HttpPartialResponse
	instanceVariableNames: 'producerBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpPartialResponse commentStamp: 'bolot 2/20/2002 13:56' prior: 0!
kom/4.12 (Comanche/4.12)

HttpPartialResponse (bolot 4/2/2001 18:49)
- not a very accurate name
- a subclass of HttpResponse
-- allows for long-execution modules to write directly to the client
!

Object subclass: #HttpSession
	instanceVariableNames: 'id attributes timestamp '
	classVariableNames: 'LastSessionID '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpSession commentStamp: 'bolot 2/20/2002 14:00' prior: 0!
kom/4.12 (Comanche/4.12)

I'm a Session in  a Http connection.!

Object subclass: #HttpSessionModule
	instanceVariableNames: 'module sessions mutex lastCleanup secondsToLive '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!HttpSessionModule commentStamp: 'bolot 2/18/2002 17:50' prior: 0!
I'm module decorator that add Session support to an existing module

Usage:
Comanche module: (HttpSessionModule module: XXXXModule new)
!

Error subclass: #HttpUnauthorized
	instanceVariableNames: 'realm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpUnauthorized commentStamp: 'bolot 2/20/2002 14:00' prior: 0!
kom/4.12 (Comanche/4.12)

HttpUnauthorized (kom/4.8; bolot 4/2/2001 18:52)
- an error that gets translated to HTTP error code 401
!

Object subclass: #Kom5Preferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!Kom5Preferences commentStamp: 'bolot 2/20/2002 13:38' prior: 0!
Kom5Preferences
- bolot 2/20/2002 13:37
- absorb all tweakable parameters of Comanche
- a single point for editing
- todo: per-server preferences!

Object subclass: #KomHtmlEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!

!KomHtmlEntity commentStamp: '<historical>' prior: 0!
KomHtmlEntity
bolot 6/20/2001 22:31

- the root of the HTML UI widget hierarchy
- each element is a wrapper for converting objects into HTML components
-- e.g., KomHtmlSelectionList -- coll as: KomHtmlSelectionList
!

KomHtmlEntity subclass: #KomHtmlForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!

!KomHtmlForm commentStamp: '<historical>' prior: 0!
KomHtmlForm
bolot 6/20/2001 22:57

- this is used in form construction, primarily in SSP
- we want to make form creation/manipulation as automatic as possible
- when we add a form on the page, all subsequent form elements belong to the form
- form generates its name and URL automatically
- when we process the form, the values submitted are processed by appropriate entities
-- ?how? -- we want to create a design pattern
- maybe forms should be associated with HTTP sessions?
-- that way, we can keep track of values
-- create a copy of KomHtmlForm for each session?!

KomHtmlEntity subclass: #KomHtmlFormEntity
	instanceVariableNames: 'form name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!
KomHtmlFormEntity subclass: #KomHtmlSelectionList
	instanceVariableNames: 'collection defaultSelection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!

!KomHtmlSelectionList commentStamp: '<historical>' prior: 0!
KomHtmlSelectionList
bolot 6/20/2001 22:47

- wrapper for collections to convert them into SELECT tag
- collection contains associations:
-- <OPTION VALUE="key">value</OPTION>!

ComancheServer subclass: #LTDComancheServer
	instanceVariableNames: 'maxThreads ltdSema '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!LTDComancheServer commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:45

LTDComancheServer
- based on Lex Spoon's limitConnections change set
-- except that it creates a subclass of ComancheServer
-- ... and renames inst vars
- maxThreads - how many connections to handle simultaneously
- ltdSema - semaphore that only allows maxThreads connections

Inst Vars:
	maxThreads		#(Integer SmallInteger)
	ltdSema			#(Semaphore)
!

ComancheNetService subclass: #LTDComancheService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!LTDComancheService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:45

LTDComancheService
- service corresponding to LTDComanchServer
- kom50 will refactor service/server/adaptor framework
-- may not be necessary to subclass all hierarchies!

Object subclass: #MultipartChunk
	instanceVariableNames: 'header properties multipartBoundary request '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!MultipartChunk commentStamp: 'bolot 2/20/2002 14:00' prior: 0!
kom/4.12 (Comanche/4.12)

MultipartChunkHeader (kom/4.8; bolot 4/2/2001 18:52)
- in kom49 (or kom50) this will be used only for internal purposes
-- applications will access multipart form fields through regular fieldAt: technique

Comment from kom46:
- this is a hack (bolot 10/25/2000 17:17)
- store a part's (from a multipart message) header information:
-- header (raw)
-- properties (extracted and converted info, such as file-name, content-length, etc.)!

Object subclass: #NetworkProtocolAdaptor
	instanceVariableNames: 'readStream writeStream target log '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol Abstract'!

!NetworkProtocolAdaptor commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:53

NetworkProtocolAdaptor

Comment from Kom46:
I represent an adaptor that adapts a network protocol into a message based dialog between me and my target.  Thus, I must have knowledge of the underlying network protocol.  My target must implement a protocol designed to work with a specific subclass.

*NOTE* At the moment, this class and subclasses only work as servers.  A small amount of additional work is needed to get them functioning as clients.

My subclasses should only be concerned with specializing for a particular network protocol.

Instance variables:

readStream - The stream to read requests or responses from.
writeStream - The stream to write requests or responses to.
target - The target object with which I will converse.
!

NetworkProtocolAdaptor subclass: #HttpAdaptor
	instanceVariableNames: 'request response startTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpAdaptor commentStamp: 'bolot 2/20/2002 13:59' prior: 0!
kom/4.12 (Comanche/4.12)

HTTPAdaptor (kom/4.8; bolot 4/2/2001 18:48)
- logging is removed from kom46 core
- so is Process>>contextAt:ifAbsent:
- kom48 adds rudimentary persistent connections
-- see keepAliveConnection senders (also in Preferences)

Comment from kom46:
I encapsulate the HTTP protocol from my clients (who must support the HttpPlug interface).  I use an HttpRequest to pick apart a request and I use an HttpResponse to formulate a response.  Mainly, I broker the conversation, turning a request into a message send (to an HttpPlug) and converting the answer to an HttpResponse.  Thus, my clients must simply implement a message based protocol (eliminating the need for them to be concerned with HTTP syntax).!

NetworkProtocolAdaptor class
	instanceVariableNames: ''!
Object subclass: #NetworkRequest
	instanceVariableNames: 'properties session '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol Abstract'!

!NetworkRequest commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:53

NetworkRequest
- a generic request object
- properties are some ad-hoc properties
- session is not currently used

Note about Kom46:
- this class contained more methods
-- some methods have been depricated since!

NetworkRequest subclass: #HttpRequest
	instanceVariableNames: 'url stream header rawUrl '
	classVariableNames: 'EndOfRequestHeaderMarker HttpStatusCodeDict '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpRequest commentStamp: 'bolot 2/20/2002 13:56' prior: 0!
kom/4.12 (Comanche/4.12)
bolot 2/20/2002 13:53
- rawUrl = the entire request string
- url = rawUrl up to ?
- queryString = rawUrl after the first ?
- rawUrl == url?queryString

HttpRequest (bolot 4/2/2001 18:51)
- HTTP request object wrapper
- handles details of HTTP
-- headers, formats, etc.
- as of kom47, handles multipart posts
- in kom49 (or kom50) a minor refactoring will happen!

NetworkRequest class
	instanceVariableNames: ''!
Object subclass: #ObjectUrlMap
	instanceVariableNames: ''
	classVariableNames: 'Index Map '
	poolDictionaries: ''
	category: 'Kom-demo'!
ComancheServer subclass: #PWSComancheServer
	instanceVariableNames: 'portNumber serverProcess priority '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!PWSComancheServer commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:46

PWSComancheServer
- a version of ComancheServer that works like PWS
-- i.e., using ConnectionQueue
!

ComancheNetService subclass: #PWSComancheService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!PWSComancheService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:46

PWSComancheService
- service for PWSComancheServer
- kom50 will refactor service/server/adaptor framework
-- won't be necessary to subclass all hierarchies!

Object subclass: #PartialResponseModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!PartialResponseModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:54

PartialResponseModule
- an example of using HttpPartialResponse
-- to serve results of a slow computation!

Object subclass: #SinglePageApp
	instanceVariableNames: 'output input '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!SinglePageApp commentStamp: '<historical>' prior: 0!
bolot 10/1/2001 01:07

output - Coll of objects that need to be output
input - Coll of input fields
urlMap - urls for automatically cached objects
!

SinglePageApp subclass: #SinglePageTurtleApp
	instanceVariableNames: 'pen form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!
Object subclass: #SinglePlugModule
	instanceVariableNames: 'processBlock urlPattern '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!SinglePlugModule commentStamp: '<historical>' prior: 0!
Kom49 (Comanche beta 4.9)
bolot 5/1/2001 02:50

SinglePlugModule

This is very similar to SinglePlugServerAction of PWS. Its processBlock is what fulfills the request. But the important difference arises because of the architectural differences between Comanche and PWS. SinglePlugModule's processBlock needs to return a value which will get served to the web browser (whereas PWS SinglePlugServerAction's processBlock needs to write, by way of #reply:, directly to the socket).

To make SinglePlugModule only respond to certain URLs, its urlPattern instance variable should be set appropriately, for example, through using #urlPrefix:, #urlSuffix:, or #urlPattern.

Here's an example (select all and do it):
| service module |
service := ComancheNetService named: 'SinglePlugExample' onPort: 8080.
module _ SinglePlugModule newBlock: [:request | request url].
module urlPrefix: '/singlePlugExample'.
service module: module.
service start

To stop the above server:
| server |
(server _ ComancheServer serverOnPort: 8080 ifAbsent: [])
	ifNotNil: [server stop].
ComancheNetService removeServiceNamed: 'SinglePlugExample'.
!

Object subclass: #StaticFileModule
	instanceVariableNames: 'folder slashXlat '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!StaticFileModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:55

StaticFileModule
- this is a "web-server proper"
-- serve files from the local file system (okay, there's NFS and Samba)
-- very simple mapping from URL to relative file path
- default folder location is 'htdocs' in FileDirectory default

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'StaticFileExample' onPort: 8000.
service module: (StaticFileModule new).
service start
!

Stream subclass: #BufferStream
	instanceVariableNames: 'buffer startPos endPos '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!BufferStream commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:43

BufferStream

Comment in Com46:
- is-a ReadWriteStream on a String
- like a queue
  removeNext:/nextPutAll: protocol!

Stream subclass: #SocketStream
	instanceVariableNames: 'socket inStream outStream status '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!SocketStream commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:47

SocketStream
- some changes to gradually enable client-side work

Comment from kom46:
SocketStream
- stream interface to Socket
- HttpRequest (and other users) don't know anything about sockets

bolot 12/16/1999 15:01
- re-doing the interface
  - inStream will replace buffer
  - outStream will be the buffer for sending data
  - nextPut:/nextPutAll: will write to outStream
  - flush will be required to send data
- TODO
  - stop using buffer, eventually remove it
!

Magnitude subclass: #TimeStamp
	instanceVariableNames: 'date time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Magnitudes'!

!TimeStamp commentStamp: '<historical>' prior: 0!
An instance of this class serves as a container for a Date and a Time.  Because TimeStamp is a subclass of Magnitude, you can do lots of interesting comparisons and arithmetic operations with TimeStamps.

Structure:
	date	 --> a Date - The day on which the TimeStamp occurs.
	time --> a Time - The time at which the TimeStamp occurs.

Examples:
	TimeStamp current
	TimeStamp date: Date today time: Time now
	TimeStamp fromString: '1-10-2000 11:55:00 am'   "MM-DD-YYYY HH:MM:SS AM"
	TimeStamp current < TimeStamp noon
!

SinglePlugModule subclass: #TurtleGraphicsModule
	instanceVariableNames: 'form pen '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!TurtleGraphicsModule commentStamp: '<historical>' prior: 0!
Kom49 (Comanche beta 4.9)
bolot 5/7/2001 18:50

TurtleGraphicsModule
- this is an example of serving two elements from the same module
-- on '/prefix/something.gif', serve the form (which converts to GIF)
-- on everything else, serve the web page
-- also, interpret form fields as commands for the turtle

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'TurtleGraphicsExample' onPort: 8000.
service module: (TurtleGraphicsModule new initialize).
service start
!

TurtleGraphicsModule subclass: #TurtleFrameGraphicsModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!TurtleFrameGraphicsModule commentStamp: '<historical>' prior: 0!
Kom49 (Comanche beta 4.9)
bolot 5/7/2001 18:53

TurtleFrameGraphicsModule
- same idea as TurtleGraphicsModule, but use two frames
-- top -- image
-- bottom -- command console!


!Object methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:17'!
asHtmlDocumentForRequest: aNetworkRequest

	self error: 
		('The requested object (', 
		self asString, 
		'), could not be converted into HTML for your browser.')! !

!Object methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:23'!
asHttpResponseTo: anHttpRequest

	^(self asHtmlDocumentForRequest: anHttpRequest) 
		asHttpResponseTo: anHttpRequest
! !

!Object methodsFor: 'MIME' stamp: 'SVP 8/17/1999 17:51'!
mimeType

	^MIMEDocument defaultContentType! !

!Object methodsFor: 'comanche' stamp: 'bolot 10/15/2001 15:57'!
asHtmlElement
	"answer my HTML representation (String),
	as I would look like inside an HTML document"

	^self asHtmlElementIn: nil! !

!Object methodsFor: 'comanche' stamp: 'bolot 10/1/2001 22:47'!
asHtmlElementIn: htmlContainer
	"answer my HTML representation (String),
	as I would look like inside htmlContainer"

	^self printString! !

!Object methodsFor: 'comanche' stamp: 'bolot 10/15/2001 16:26'!
comancheUrl
	^ObjectUrlMap urlForObject: self ifAbsent: [ObjectUrlMap autoMap: self]! !

!Object methodsFor: 'comanche' stamp: 'bolot 10/16/2001 21:27'!
makeAvailableInComanche
	"force putting the object on the ObjUrlMap list"
	self comancheUrl! !


!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:16'!
cacheRootUrl
	^'/kom/cache/'! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:19'!
clearObjectCache
	urlMap _ Dictionary new! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:17'!
generateUniqueUrlForObject: anObject
	"prepend a special root URL"
	^self cacheRootUrl, anObject hash asString, '/', Time totalSeconds asString! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:19'!
initialize
	urlMap _ Dictionary new.
	urlPrefixMap _ Dictionary new! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:20'!
mapObject: anObject
	"generate a random, unique URL, add the object there"
	urlMap at: (self generateUniqueUrlForObject: anObject) put: anObject! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:20'!
mapPrefix: aString to: aModule
	"make a given prefix map to the module"
	urlPrefixMap at: aString put: aModule! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:24'!
process: request
	"first, check if any cached objects are referenced"
	(urlMap includesKey: request url)
		ifTrue: [^urlMap at: request url].

	"then check if any application's prefix matches"
	urlPrefixMap keysAndValuesDo: [:urlPrefix :module |
		(request url beginsWith: urlPrefix) ifTrue: [^module process: request]].

	"otherwise, the default response"
	^nil! !


!ChieftainModule class methodsFor: 'examples' stamp: 'bolot 6/21/2001 03:48'!
basicExample
	"ChieftainModule basicExample"

	| service chief |
	chief _ self new initialize.
	chief
		mapPrefix: '/displaycam' to: DisplayCamModule new;
		mapPrefix: '/helloworld' to: HelloWorldModule new;
		mapPrefix: '/turtlegraphics' to:
				(TurtleGraphicsModule new initialize urlPrefix: '/turtlegraphics');
		mapPrefix: '/turtleframe' to:
				(TurtleFrameGraphicsModule new initialize urlPrefix: '/turtleframe').

	service := ComancheNetService named: 'basicExample' onPort: 8017.
	service module: chief.
	service start
! !


!Color methodsFor: 'printing' stamp: 'bolot 3/17/2001 22:16'!
hex
	^(self red * 255) asInteger asCharacter hex,
	(self green * 255) asInteger asCharacter hex,
	(self blue * 255) asInteger asCharacter hex! !


!ComancheServer methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:35'!
initializeOnPort: aNumber priority: pNum serviceProvider: sp
	connectionHandler ifNotNil: [ connectionHandler stop ].
	connectionHandler _ ConnectionHandler
		onPort: aNumber
		handler: self
		priority: pNum.
	serviceProvider _ sp! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:30'!
connectionHandler
	^connectionHandler! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:13'!
portNumber
	self connectionHandler
		ifNotNil: [^self connectionHandler portNumber]
		ifNil: [^nil]! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:30'!
priority
	^self connectionHandler priority! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority: priorityLevel

	self connectionHandler priority: priorityLevel! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:31'!
serviceProvider
	^serviceProvider! !

!ComancheServer methodsFor: 'private' stamp: 'bolot 12/18/2000 23:30'!
register
	(self class portTaken: self portNumber) ifFalse: [
		self class register: self.
		^self
	].
	self error: ('There is already an active server on port ', self portNumber asString)! !

!ComancheServer methodsFor: 'private' stamp: 'bolot 12/18/2000 23:30'!
unregister
	self class unregister: self! !

!ComancheServer methodsFor: 'private' stamp: 'bolot 12/19/2000 00:23'!
value: aSocket
	[ self serviceProvider serve: aSocket ] fork! !

!ComancheServer methodsFor: 'queries' stamp: 'bolot 12/18/2000 23:14'!
isRunning
	self connectionHandler
		ifNotNil: [^self connectionHandler isRunning]
		ifNil: [^false]! !

!ComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 1/31/2001 23:46'!
start
	self register.
	Socket initializeNetwork.
	self connectionHandler start! !

!ComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:44'!
stop
	self connectionHandler stop.
	self unregister.
	connectionHandler _ serviceProvider _ nil! !

!ComancheServer methodsFor: 'printing' stamp: 'bolot 12/18/2000 23:29'!
printOn: aStream
	aStream nextPutAll: ('ComancheServer port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	]! !


!ComancheServer class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 18:12'!
onPort: aNumber priority: pNum serviceProvider: sp
	^super new initializeOnPort: aNumber priority: pNum serviceProvider: sp! !

!ComancheServer class methodsFor: 'initialization' stamp: 'bolot 1/11/2001 14:56'!
initialize
	" ComancheServer initialize "

	Servers _ Dictionary new! !

!ComancheServer class methodsFor: 'accessing' stamp: 'bolot 1/11/2001 14:58'!
serverOnPort: portNumber ifAbsent: absentBlock 
	^self servers at: portNumber ifAbsent: absentBlock! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
portTaken: portNumber
	self servers at: portNumber ifAbsent: [ ^false ].
	^true! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
register: aComancheServer
	self servers at: aComancheServer portNumber ifAbsent: [
		^self servers at: aComancheServer portNumber put: aComancheServer.
	].
	self error: ('A server is already registered on port ', aComancheServer portNumber)! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
servers
	^Servers! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
unregister: aComancheServer
	self servers removeKey: 
		(self servers keyAtIdentityValue: aComancheServer ifAbsent: [ ^self ])! !


!ComancheService methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:56'!
initialize
	autoStart _ false! !

!ComancheService methodsFor: 'registration' stamp: 'bolot 12/16/2000 18:59'!
registerAs: aString
	self unregister.
	self class addService: self named: aString! !

!ComancheService methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:00'!
unregister
	self stop.
	self class removeService: self! !

!ComancheService methodsFor: 'startup and shutdown' stamp: 'bolot 12/16/2000 18:59'!
prepareForShutdown
	"The squeak system is about to shutdown"! !

!ComancheService methodsFor: 'startup and shutdown' stamp: 'bolot 12/16/2000 18:59'!
prepareForStartup
	"The squeak system just started up"! !

!ComancheService methodsFor: 'printing' stamp: 'bolot 12/16/2000 18:59'!
printOn: aStream
	aStream nextPutAll: ('Service: ', self name).
	self isRunning ifTrue: [ 
		aStream nextPutAll: '[running]'
	] ifFalse: [
		aStream nextPutAll: '[stopped]'
	]! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:57'!
autoStart
	^autoStart == true! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
autoStart: aBoolean
	autoStart _ aBoolean! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
log
	^log! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
log: aLog
	log _ aLog! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
name
	^self class nameForService: self! !

!ComancheService methodsFor: 'queries' stamp: 'bolot 12/16/2000 18:58'!
isRunning
	self subclassResponsibility! !

!ComancheService methodsFor: 'starting and stopping' stamp: 'bolot 12/16/2000 19:00'!
start
	"Subclasses should override this method to take whatever
	is necessary to start this service"

	"self subclassResponsibility"! !

!ComancheService methodsFor: 'starting and stopping' stamp: 'bolot 12/16/2000 19:00'!
stop
	"Subclasses should override this method to take whatever
	is necessary to start this service"

	"self subclassResponsibility"! !


!ComancheNetService methodsFor: 'initialization' stamp: 'bolot 2/5/2001 19:47'!
initializeOnPort: portNum priority: priorityLevel protocolAdaptor: aPA
	comancheServer _ self defaultServerClass 
		onPort: portNum
		priority: priorityLevel
		serviceProvider: self.

	protocolAdaptor _ aPA! !

!ComancheNetService methodsFor: 'initialization' stamp: 'bolot 2/5/2001 19:47'!
initializeOnPort: portNum priority: priorityLevel protocolAdaptor: aPA serverClass: serverClass
	comancheServer _ serverClass 
		onPort: portNum
		priority: priorityLevel
		serviceProvider: self.

	protocolAdaptor _ aPA! !

!ComancheNetService methodsFor: 'defaults' stamp: 'SVP 8/13/1999 14:13'!
defaultProtocolAdaptor

	^self class defaultProtocolAdaptor! !

!ComancheNetService methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:46'!
defaultServerClass
	^self class defaultServerClass! !

!ComancheNetService methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:46'!
start
	self comancheServer ifNotNil: [
		self comancheServer start
	]! !

!ComancheNetService methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:45'!
stop
	self comancheServer ifNotNil: [
		self comancheServer stop
	].
	comancheServer _ nil.
	module _ nil.
	protocolAdaptor _ nil! !

!ComancheNetService methodsFor: 'conversation' stamp: 'bolot 12/18/2000 23:46'!
processNetworkRequest: aNetworkRequest
	^self module process: aNetworkRequest! !

!ComancheNetService methodsFor: 'conversation' stamp: 'bolot 12/18/2000 22:47'!
serve: aSocket
	"Provided for TCP/IP conversations.  Works in conjunction with 
	a ComancheServer.  Services that do not serve TCP/IP connections
	do not need to implement this method."

	self protocolAdaptor 
		readAndWriteTo: (SocketStream on: aSocket)
		target: self! !

!ComancheNetService methodsFor: 'queries' stamp: 'bolot 1/11/2001 15:00'!
isRunning
	self comancheServer ifNotNil: [ 
		^self comancheServer isRunning
	].
	^false! !

!ComancheNetService methodsFor: 'printing' stamp: 'bolot 1/11/2001 15:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' port: ', self portNumber asString! !

!ComancheNetService methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:00'!
comancheServer
	^comancheServer! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:25'!
module
	"Answer a ComancheModule that will process network
	requests for this ComancheNetService"

	^module! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:30'!
module: aComancheModule

	module _ aComancheModule! !

!ComancheNetService methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:15'!
portNumber
	self comancheServer
		ifNotNil: [^self comancheServer portNumber]
		ifNil: [^nil]! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority

	^self comancheServer priority! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:13'!
protocolAdaptor
	"Answer the NetworkProtocolAdaptor that is being used to
	translate Socket based conversations into message based ones."
	"HttpAdaptor is the default protocol adaptor."

	^protocolAdaptor! !


!ComancheService class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 19:02'!
named: aString
	^self new registerAs: aString! !

!ComancheService class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 19:02'!
new
	^super new initialize! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
addService: aComancheService named: aString
	| tmp |
	tmp _ self services.
	(tmp includesKey: aString)
		ifTrue: [ ^self error: 'A service by the same name already exists' ].
	tmp at: aString put: aComancheService! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
nameForService: aComancheService
	^self services 
		keyAtIdentityValue: aComancheService 
		ifAbsent: [ '(unregisterd service)' ]! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
removeService: aComancheService
	| tmp |
	tmp _ self services.
	tmp removeKey: 
		(tmp keyAtIdentityValue: aComancheService ifAbsent: [ ^self ])! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
removeServiceNamed: aString
	self services removeKey: aString ifAbsent: []! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
replaceServiceNamed: aString with: aComancheService
	self services at: aString put: aComancheService! !

!ComancheService class methodsFor: 'registration' stamp: 'gh 1/7/2002 12:57'!
serviceNamed: aString
	^self services at: aString ifAbsent: [nil]! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:02'!
services
	^Services! !

!ComancheService class methodsFor: 'snapshots' stamp: 'bolot 12/16/2000 19:02'!
shutDown
	self services do: [ :ea |
		ea prepareForShutdown
	]! !

!ComancheService class methodsFor: 'snapshots' stamp: 'bolot 12/16/2000 19:02'!
startUp
	self services do: [ :ea |
		ea prepareForStartup
	].
	self services do: [ :ea |
		ea autoStart ifTrue: [ ea start ]
	]! !

!ComancheService class methodsFor: 'accessing' stamp: 'bolot 12/16/2000 19:03'!
defaultPriority
	^Processor highIOPriority! !

!ComancheService class methodsFor: 'accessing' stamp: 'bolot 1/16/2001 11:39'!
defaultSearchPriority
	^self defaultPriority - 1! !

!ComancheService class methodsFor: 'initialization' stamp: 'bolot 12/16/2000 19:03'!
initialize
	" ComancheService initialize  "

	Services _ Dictionary new.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self! !


!ComancheNetService class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:00'!
named: aString onPort: portNumber
	^self named: aString onPort: portNumber priority: self defaultPriority! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:01'!
named: aString onPort: portNumber priority: priorityNum
	^self 
		named: aString 
		onPort: portNumber 
		priority: priorityNum 
		protocolAdaptor: self defaultProtocolAdaptor! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:01'!
named: aString onPort: portNumber priority: priorityNum protocolAdaptor: aPA
	^(super named: aString) 
		initializeOnPort: portNumber priority: priorityNum protocolAdaptor: aPA! !

!ComancheNetService class methodsFor: 'defaults' stamp: 'SVP 8/13/1999 14:13'!
defaultProtocolAdaptor

	^HttpAdaptor! !

!ComancheNetService class methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:47'!
defaultServerClass
	^ComancheServer! !


!ConnectionHandler methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:27'!
destroySockets
	socketsToDestroy ~~ nil ifTrue: [ 
		socketsToDestroy do: [ :ea | ea destroy ].
	].
	socketsToDestroy _ OrderedCollection new! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'svp 12/1/1999 18:52'!
finalize

	"Like #stop, but without the #unregister"

	process ~~ nil ifTrue: [
		process terminate.
	].
	process _ nil.
	self destroySockets.


! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:38'!
initializeOnPort: aNumber handler: aBlock priority: pNumber
	portNumber _ aNumber.
	handlerBlock _ aBlock.
	priority _ pNumber.
	socketsToDestroy _ OrderedCollection new! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:45'!
initializeProcessAtPriority: pNumber
	process _ [ self pvtListenLoop ] newProcess.
	process priority: pNumber! !

!ConnectionHandler methodsFor: 'starting and stopping' stamp: 'bolot 12/16/2000 18:42'!
start
	self stop.
	self process resume.
	self register! !

!ConnectionHandler methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:57'!
stop
	self unregister.
	process ~~ nil ifTrue: [
		process terminate.
	].
	process _ nil.

	"We do the following in a timely manner instead of relying on
	finalization because we may want to turn right around and start
	listening again.  If an old socket is still around an listening, it may
	interfere with a new one's ability to hear."

	self destroySockets! !

!ConnectionHandler methodsFor: 'registry' stamp: 'svp 12/1/1999 18:46'!
register

	^self class register: self! !

!ConnectionHandler methodsFor: 'registry' stamp: 'svp 12/1/1999 18:46'!
unregister

	^self class unregister: self! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 2/11/2002 14:38'!
newListener
	| listener |

	self flag: #todo. "listener _ self socketClass newTCP."
	listener _ Socket newTCP.

	"backlog is how many simultaneous connections to accept at the same time"
	listener listenOn: portNumber backlogSize: Kom5Preferences backlogSize.
	^listener! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 12/19/2000 00:24'!
pvtListenLoop
	[
		self pvtNewListenLoop
	] on: Error do: [ :ex |
		process _ nil.
		self destroySockets.
	]! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 2/20/2002 13:30'!
pvtNewListenLoop
	| socket listener |

	listener _ self newListener.
	self socketsToDestroy add: listener.	

	"If the listener is not valid then the we cannot use the
	BSD style accept() mechanism."
	listener isValid ifFalse: [^self pvtOldListenLoop].
	[ true ] whileTrue: [
		socket _ listener waitForAcceptUntil: Kom5Preferences acceptTimeoutDeadline.
		(socket notNil and: [ socket isConnected ])
			ifTrue: [
				handlerBlock value: socket.
				socket _ nil]
			ifFalse: [
				socket notNil ifTrue: [socket destroy].
				listener isValid
					ifFalse: [(Delay forMilliseconds: Kom5Preferences listenerDestroyDelay) wait.
						listener destroy.
						listener _ self newListener].
			].
	]! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 12/19/2000 00:24'!
pvtOldListenLoop
	"see comment on ConnectionQueue>>oldStyleListenLoop"
	| socket |
	socket _ nil.

	[ true ] whileTrue: [
		(socket == nil) ifTrue: [
			"try to create a new socket for listening"
			socket _ Socket createIfFail: [ nil ]].

		(socket == nil)
		ifTrue: [(Delay forMilliseconds: 100) wait]
		ifFalse: [
			socket isUnconnected ifTrue: [ socket listenOn: portNumber ].
			socket waitForConnectionUntil: (Socket deadlineSecs: 10).
			socket isConnected
				ifTrue: ["connection established"
					"mutex critical: [" handlerBlock value: socket "]".
					socket _ nil]
				ifFalse: [
					socket isWaitingForConnection
						ifFalse: [socket destroy. socket _ nil]].
		].
	]! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:01'!
portNumber
	^portNumber! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:01'!
priority
	^priority! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:01'!
process
	process == nil ifTrue: [
		self initializeProcessAtPriority: self priority.
	].
	^process! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:58'!
socketsToDestroy

	socketsToDestroy == nil ifTrue: [
		socketsToDestroy _ OrderedCollection new.
	].
	^socketsToDestroy! !

!ConnectionHandler methodsFor: 'printing' stamp: 'bolot 1/11/2001 15:02'!
printOn: aStream
	aStream nextPutAll: (self class name asString, ' port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	]! !

!ConnectionHandler methodsFor: 'queries' stamp: 'svp 12/1/1999 17:51'!
isRunning

	^process ~~ nil! !


!ConnectionHandler class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 18:43'!
onPort: aNumber handler: aBlock priority: pNum
	^self new
		initializeOnPort: aNumber
		handler: aBlock
		priority: pNum! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:49'!
register: anObject

	self registry add: anObject! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:49'!
registry

	Registry == nil ifTrue: [
		Registry := WeakRegistry new
	].
	^Registry! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:50'!
unregister: anObject

	self registry remove: anObject ifAbsent: [ ]! !


!Date methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:32'!
asTimeStamp
	"Answer the receiver as a TimeStamp at midnight."

	^TimeStamp date: self time: (Time fromSeconds: 0)! !

!Date methodsFor: 'printing' stamp: 'bolot 2/22/2001 17:00'!
yyyymmdd
	"no delimiters"
	"Date today yyyymmdd"

	^ self printFormat: #(3 2 1 $- 1 1 2)! !


!DisplayCamModule methodsFor: 'kom-processing' stamp: 'bolot 4/2/2001 16:21'!
process: request
	^Display magnifyBy: 1/8 ! !


!Form methodsFor: 'comanche processing' stamp: 'bolot 10/15/2001 16:27'!
asHtmlElementIn: htmlContainer
	"answer my HTML representation (String),
	as I would look like inside htmlContainer"

	^'<IMG SRC="', self comancheUrl, '">'! !

!Form methodsFor: 'comanche processing' stamp: 'bolot 2/14/2000 15:59'!
asHttpResponseTo: request
	^HttpResponse fromMIMEDocument: self asWebImage! !

!Form methodsFor: 'comanche processing' stamp: 'bolot 12/18/2000 22:31'!
asWebImage
	"return a MIMEDocument"
	| aStream |
	aStream _ (RWBinaryOrTextStream on: '').
	GIFReadWriter putForm: (self asFormOfDepth: 8) onStream: aStream.
	aStream reset.
	^MIMEDocument contentType: MIMEDocument contentTypeGif content: aStream! !


!HelloWorldModule methodsFor: 'comanche' stamp: 'bolot 2/5/2001 19:33'!
process: request
	^'Hello World!!'! !


!HtmlComancheForm class methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:16'!
formElementFromSpec: spec
	"spec is (formFieldName type [label])"

	| type fieldName label |
	type _ spec at: 2.
	fieldName _ spec at: 1.
	label _ spec at: 3 ifAbsent: [fieldName asString].

	type == #Integer
		ifTrue: [^'<input type="text" name="', fieldName asString, '">'].

	type == #SubmitButton
		ifTrue: [^'<input type="submit" name="', label, '" value="', label, '">'].

	^'<input type="hidden" name="', label, '">'! !

!HtmlComancheForm class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:46'!
formFieldNamed: fieldName specMatrix: specMatrix request: request
	"spec is (formFieldName type [label]), specMatrix is an Array of specs"

	| type label spec |
	spec _ specMatrix detect: [:elem | elem first = fieldName asString] ifNone: [^nil].
	type _ spec at: 2.
	label _ spec at: 3 ifAbsent: [fieldName asString].

	type == #Integer
		ifTrue: [^(request getFields at: fieldName asString) asInteger].

	type == #SubmitButton
		ifTrue: [^request getFields includesKey: fieldName asString].

	^nil! !


!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:25'!
at: key
	^(super at: key) first! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:27'!
at: key put: value
	(self includesKey: key)
		ifFalse: [super at: key put: (OrderedCollection new)].

	(super at: key) add: value.

	^value! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:25'!
booleanAt: key
	^(self at: key) = 'true'! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:34'!
booleansAt: key
	^(self rawAt: key) collect: [:value | value == 'true']! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:33'!
numberAt: key
	^[(self at: key) asNumber]
		ifError: [:err :rcvr | Float nan]! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:34'!
numbersAt: key
	^(self rawAt: key) collect: [:value |
		[value asNumber] ifError: [:err :rcvr | Float nan]]! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:30'!
rawAt: key
	^super at: key! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:35'!
stringAt: key
	^self at: key! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:35'!
stringsAt: key
	^(self rawAt: key) copy! !


!HttpParser class methodsFor: 'utilities' stamp: 'bolot 6/22/2001 12:28'!
addKey: key value: value toForm: dict multipleValues: boolean
	boolean
		ifTrue: [dict at: key put: value]
		ifFalse: [(dict includesKey: key)
			ifFalse: [dict at: key put: value]
			ifTrue: [dict at: key modify: [:oldValue | oldValue, value]]]! !

!HttpParser class methodsFor: 'utilities' stamp: 'bolot 6/22/2001 12:06'!
decodeUrlEncodedForm: string
	^self decodeUrlEncodedForm: string multipleValues: false! !

!HttpParser class methodsFor: 'utilities' stamp: 'bolot 6/22/2001 12:27'!
decodeUrlEncodedForm: string multipleValues: boolean
	| dict key value start end eqSignPos more |
	dict _ boolean ifTrue: [HttpFormDictionary new] ifFalse: [Dictionary new].
	string isEmptyOrNil ifTrue: [^dict].
	more _ true.
	start _ 1.
	[end _ string indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	eqSignPos _ string indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key _ (key _ string copyFrom: start to: end) unescapePercents.
			value _ '']
		ifFalse: [key _ (key _ string copyFrom: start to: eqSignPos-1) unescapePercents.
			value _ (value _ string copyFrom: eqSignPos+1 to: end) unescapePercents].
	self addKey: key value: value toForm: dict multipleValues: boolean.
	start _ end + 2.
	more] whileTrue.

	^dict! !

!HttpParser class methodsFor: 'utilities' stamp: 'bolot 12/16/2000 03:21'!
parseHttpHeader: string
	| dict key value start end more colonPos fieldDelims lastKey keyValueDelim |
	dict _ Dictionary new.
	string isEmptyOrNil ifTrue: [^dict].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ end _ 1.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue:
					[dict
						at: lastKey
						modify: [:item | item, (string copyFrom: start to: end)]]
				ifFalse:
					[colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue:
							[key _ (string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse:
							[key _ (string copyFrom: start to: colonPos-1) asLowercase.
							value _ (string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [dict at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue.

	^dict! !


!HttpRedirect methodsFor: 'as yet unclassified' stamp: 'bolot 3/31/2001 15:39'!
asHttpResponseTo: request

	^(HttpResponse
			status: #tempMoved
			description: 'Temporarily moved to: <A HREF="', location, '">', location, '</A>')
		fieldAt: 'Location' put: location;
		fieldAt: 'URI' put: location;
	yourself! !

!HttpRedirect methodsFor: 'as yet unclassified' stamp: 'bolot 12/16/2000 02:24'!
signalLocation: aString

	location _ aString.
	self signal.! !


!HttpResponse methodsFor: 'initialize-release' stamp: 'SVP 8/26/1999 08:06'!
destroy

	self contents close.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contentType

	^contentType! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contentType: aMimeType

	contentType _ aMimeType! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
contents

	^contents! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contents: aStream

	contents _ aStream! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString

	^self fields at: aString! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString ifAbsent: absBlock

	^self fields at: aString ifAbsent: absBlock! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString ifAbsentPut: absBlock

	^self fields at: aString ifAbsentPut: absBlock! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:07'!
fieldAt: aString put: aValue

	self fields at: aString put: aValue! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:07'!
fields

	fields ifNil: [
		fields _ Dictionary new.
	].

	^fields! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 12/16/1999 11:33'!
httpVersion

	^'HTTP/1.1'! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/23/1999 11:00'!
request

	^request
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/23/1999 11:00'!
request: anHttpRequest

	request _ anHttpRequest.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
status

	^status! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
status: aSymbol

	status _ aSymbol! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/18/1999 13:03'!
statusCode

	^(StatusCodes at: self status) key.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/26/1999 10:41'!
statusCodeAndReason
	| tmp |

	tmp _ StatusCodes at: self status.
	^tmp key, ' ', tmp value.! !

!HttpResponse methodsFor: 'comanche processing' stamp: 'bolot 1/11/2001 17:51'!
asHttpPartialResponseBlock: aBlock
	^(self as: HttpPartialResponse)
		producerBlock: aBlock;
		yourself! !

!HttpResponse methodsFor: 'comanche processing'!
asHttpResponseTo: aRequest
	^self! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:28'!
pvtWriteContentLengthOn: aStream
	aStream
		nextPutAll: 'Content-length: ';
		nextPutAll: self contents size asString;
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:27'!
pvtWriteContentTypeOn: aStream
	aStream
		nextPutAll: 'Content-type: ';
		nextPutAll: self contentType;
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:28'!
pvtWriteContentsOn: aStream
	| chunkSize cnts |
	chunkSize _ self defaultChunkSize.
	cnts _ self contents.

	[ cnts atEnd ] whileFalse: [
		aStream nextPutAll: (cnts next: chunkSize); flush.
		"Processor yield."
	]! !

!HttpResponse methodsFor: 'responding' stamp: 'DGD 7/20/2001 00:34'!
pvtWriteCookiesOn: aStream 
	cookies isEmptyOrNil
		ifTrue: [^ self].
	cookies
		do: [:cookie | aStream nextPutAll: 'Set-Cookie: ';
				 nextPutAll: cookie;
				 nextPutAll: String crlf]! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:26'!
pvtWriteFieldsOn: aStream
	fields isEmptyOrNil ifTrue: [ ^self ].

	fields keysAndValuesDo: [ :k :v |
		aStream
			nextPutAll: k;
			nextPutAll: ': ';
			nextPutAll: v;
			nextPutAll: String crlf
	]! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 6/21/2001 04:03'!
pvtWriteServerOn: aStream
	aStream
		nextPutAll: 'Server: Comanche/kom-4.10';
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:29'!
pvtWriteStatusOn: aStream
	aStream
		nextPutAll: self httpVersion;
		nextPut: $ ;
		nextPutAll: self statusCodeAndReason;
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 2/20/2002 13:18'!
writeOn: aStream

	| tmp |
	"Header"

	tmp _ WriteStream on: ''.
	self pvtWriteStatusOn: tmp.
	self pvtWriteServerOn: tmp.
	self pvtWriteFieldsOn: tmp.
	self pvtWriteCookiesOn: tmp.
	self pvtWriteContentTypeOn: tmp.
	self pvtWriteContentLengthOn: tmp.
	tmp nextPutAll: String crlf.
	aStream nextPutAll: tmp contents; flush.

	"Body"
	self pvtWriteContentsOn: aStream! !

!HttpResponse methodsFor: 'defaults' stamp: 'bolot 2/20/2002 13:36'!
defaultChunkSize

	^ Kom5Preferences defaultResponseChunkSize! !

!HttpResponse methodsFor: 'defaults' stamp: 'SVP 8/12/1999 14:08'!
defaultContentType

	^MIMEDocument contentTypeHtml! !

!HttpResponse methodsFor: 'accessing-cookies' stamp: 'DGD 7/20/2001 00:25'!
cookies
^ cookies ifNil:[cookies _ OrderedCollection new]! !

!HttpResponse methodsFor: 'accessing-cookies' stamp: 'DGD 7/20/2001 00:30'!
setCookieName: nameString value: valueString expiresDate: expiresDate expiresTime: expiresTime path: pathString domain: domainString secure: secureBoolean 
	"set a cookie in the Response"
	| temp |
	temp _ String new writeStream.
	"NAME=VALUE"
	temp nextPutAll: nameString;
		 nextPut: $=;
		 nextPutAll: valueString.
	"; expires=Wdy, DD-Mon-YYYY HH:MM:SS GMT"
	(expiresDate notNil and:[ expiresTime notNil])
		ifTrue: [temp nextPutAll: '; expires=';
				 nextPutAll: expiresDate weekday;
				 nextPutAll: ', '.
			expiresDate printOn: temp format: #(1 2 3 $- 2 2 2 ).
			temp nextPutAll: ' ';
				 nextPutAll: expiresTime print24;
				 nextPutAll: ' GMT'].
	"; path=PATH"
	pathString notNil
		ifTrue: [temp nextPutAll: '; path=';
				 nextPutAll: pathString].
	"; domain=DOMAIN"
	domainString notNil
		ifTrue: [temp nextPutAll: '; domain=';
				 nextPutAll: domainString].
	"; secure"
	(secureBoolean notNil
			and: [secureBoolean])
		ifTrue: [temp nextPutAll: '; secure'].
	""
	self cookies add: temp contents! !

!HttpResponse methodsFor: 'accessing-cookies' stamp: 'DGD 7/20/2001 00:24'!
setCookieName: nameString value: valueString path: pathString 
	"set a cookie in the Response"
	self
		setCookieName: nameString
		value: valueString
		expiresDate: nil
		expiresTime: nil
		path: pathString
		domain: nil
		secure: nil! !


!HttpPartialResponse methodsFor: 'accessing' stamp: 'bolot 1/11/2001 17:49'!
producerBlock: aBlock
	producerBlock _ aBlock! !

!HttpPartialResponse methodsFor: 'responding' stamp: 'bolot 1/11/2001 17:50'!
pvtWriteContentLengthOn: aStream
	"do nothing, since the length is not known yet"
	self flag: #todo. "in HTTP/1.1, can set chunking"! !

!HttpPartialResponse methodsFor: 'responding' stamp: 'bolot 1/11/2001 17:49'!
pvtWriteContentsOn: aStream
	producerBlock value: aStream! !


!HttpResponse class methodsFor: 'initialization' stamp: 'SVP 8/16/1999 16:43'!
initialize
	"  HttpResponse initialize  "

	self initializeStatusCodes.! !

!HttpResponse class methodsFor: 'initialization' stamp: 'SVP 8/16/1999 12:17'!
initializeStatusCodes
	"  HttpResponse initializeStatusCodes  "

	StatusCodes _ IdentityDictionary new
		at: #ok				put: ('200' -> 'OK');
		at: #created			put: ('201' -> 'Created');
		at: #accepted		put: ('202' -> 'Accepted');
		at: #noContent		put: ('204' -> 'No Content');
		at: #permMoved		put: ('301' -> 'Moved Permanently');
		at: #tempMoved		put: ('302' -> 'Moved Temporarily');
		at: #notModified		put: ('304' -> 'Not Modified');
		at: #badRequest		put: ('400' -> 'Bad Request');
		at: #unauthorized	put: ('401' -> 'Unauthorized');
		at: #forbidden		put: ('403' -> 'Forbidden');
		at: #notFound		put: ('404' -> 'Not Found');
		at: #serverError		put: ('500' -> 'Internal Server Error');
		at: #notImplemented	put: ('501' -> 'Not Implemented');
		at: #badGateway	put: ('502' -> 'Bad Gateway');
		at: #serviceUnavailable	put: ('503' -> 'Service Unavailable');
 		yourself.! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromFileStream: aStream

	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aStream mimeType;
		contents: (AsyncFile from: aStream);
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromMIMEDocument: aMIMEDoc
	| content |

	content _ aMIMEDoc content.
	(content isKindOf: String) ifTrue: [
		content _ ReadStream on: content.
	].
	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aMIMEDoc mimeType;
		contents: content;
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:02'!
fromRedirect: redirect
	| tmp |
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: (tmp _ redirect fullHttpUrl);
		fieldAt: 'pragma' put: 'no-cache';
		fieldAt: 'Cache-control' put: 'private';
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', tmp,'">here</a>.</body>');
		yourself! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromStream: aStream

	^self new
		status: #ok;
		"fieldAt: 'Expires' put: 'Thu, 15 Apr 2010 20:00:00 GMT';"
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aStream mimeType;
		contents: aStream;
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 18:27'!
fromString: aString

	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: aString);
		yourself! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:02'!
fromUrl: aUrl
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: aUrl asString;
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', aUrl asString,'">here</a>.</body>');
		yourself! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 11/30/1999 14:41'!
status: aSymbol description: aString

	^self new
		status: aSymbol;
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: aString);
		yourself
! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'SVP 8/17/1999 19:04'!
status: aSymbol mimeDescription: aMIMEDocument
	| content |

	content _ aMIMEDocument content.
	(content isKindOf: String) ifTrue: [
		content _ ReadStream on: content.
	].
	^self new
		status: aSymbol;
		contentType: aMIMEDocument mimeType;
		contents: content;
		yourself
! !


!HttpSession methodsFor: 'accessing' stamp: 'DGD 7/24/2001 20:35'!
attributes
"answer the attributes stored in Session"
	^ attributes! !

!HttpSession methodsFor: 'accessing' stamp: 'DGD 7/24/2001 21:00'!
id
^id! !

!HttpSession methodsFor: 'accessing' stamp: 'DGD 7/24/2001 20:37'!
timestamp:aNumber
timestamp _ aNumber! !

!HttpSession methodsFor: 'asking' stamp: 'DGD 7/24/2001 20:40'!
usedSince: deadLineNumber 
	^ timestamp  < deadLineNumber! !

!HttpSession methodsFor: 'initialization' stamp: 'DGD 7/24/2001 21:00'!
initialize
	attributes _ Dictionary new.
id _ self class nextSessionID! !

!HttpSession methodsFor: 'printing' stamp: 'DGD 7/24/2001 21:08'!
printOn: aStream 
	aStream nextPutAll: self class name;
nextPutAll: ' id:';
		 nextPutAll: id asString;
nextPutAll: ' attributes:';
		 nextPutAll: attributes asString;
nextPutAll: ' timestamp:';
		 nextPutAll: timestamp asString! !

!HttpSession methodsFor: 'user authentication' stamp: 'bolot 2/18/2002 19:17'!
userObject
	^self attributes at: 'userObject' ifAbsent: []! !

!HttpSession methodsFor: 'user authentication' stamp: 'bolot 2/18/2002 19:17'!
userObject: anObject
	^self attributes at: 'userObject' put: anObject! !

!HttpSession methodsFor: 'user authentication' stamp: 'bolot 2/18/2002 19:16'!
username
	^self attributes at: 'username' ifAbsent: []! !

!HttpSession methodsFor: 'user authentication' stamp: 'bolot 2/18/2002 19:18'!
username: aName
	^self attributes at: 'username' put: aName! !


!HttpSession class methodsFor: 'class initialization' stamp: 'DGD 7/24/2001 20:58'!
initialize
	LastSessionID _ Time totalSeconds.! !

!HttpSession class methodsFor: 'instance creation' stamp: 'DGD 7/24/2001 20:33'!
new
^ super new initialize! !

!HttpSession class methodsFor: 'session id' stamp: 'DGD 7/24/2001 20:59'!
nextSessionID
	self flag: #TODO.
	"more robust unique number"
	LastSessionID _ LastSessionID + 1.
	^ (65535 atRandom hex allButFirst: 3)
		, (LastSessionID hex allButFirst: 3)
		, (65535 atRandom hex allButFirst: 3)! !


!HttpSessionModule methodsFor: 'initialization' stamp: 'DGD 7/24/2001 21:04'!
initialize
	sessions _ Dictionary new.
	mutex _ Semaphore forMutualExclusion.

	lastCleanup _ Time totalSeconds.
	"30 minutes"
	secondsToLive _ 30 * 60! !

!HttpSessionModule methodsFor: 'initialization' stamp: 'DGD 7/24/2001 00:40'!
initializeModule:aModule
module _ aModule! !

!HttpSessionModule methodsFor: 'accessing' stamp: 'bolot 2/20/2002 13:43'!
module
	^module! !

!HttpSessionModule methodsFor: 'accessing' stamp: 'DGD 7/24/2001 21:05'!
secondsToLive:anInteger
secondsToLive _ anInteger! !

!HttpSessionModule methodsFor: 'comanche' stamp: 'DGD 7/24/2001 21:44'!
process: aRequest 
	"process the request for session handling, then delegate #process: to the 
	decorated module, and send the new cookie to the browser"
	| response newSessionID |
	newSessionID _ self processRequestForSession: aRequest.
	response _ (module process: aRequest)
				asHttpResponseTo: aRequest.
	newSessionID notNil
		ifTrue: [response
				setCookieName: #SessionID
				value: newSessionID
				path: '/'].
	^ response! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:34'!
checkForCleanup
"PRIVATE: run the cleanup between time and time"
	lastCleanup + 60 < Time totalSeconds
		ifTrue: [self cleanup]! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:33'!
cleanup
"PRIVATE: iterate over all sessions and removes old ones"
	| totalSeconds deadLine session |
	totalSeconds _ Time totalSeconds.
	lastCleanup _ totalSeconds.
	deadLine _ totalSeconds - secondsToLive.
	sessions keys
		do: [:key | 
			session _ sessions at: key.
			(session usedSince: deadLine)
				ifTrue: [sessions removeKey: key]]! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:22'!
currentSession: aRequest 
	"PRIVATE: answer the current session based on the 'SessionID' cookie"
	| sessionID |
	sessionID _ aRequest cookies
				at: #SessionID
				ifAbsent: [^ nil].
	^ sessions
		at: sessionID
		ifAbsent: []! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:33'!
newSession
	"PRIVATE: creates a new Session and stores it"
	| session |
	session _ HttpSession new.
	sessions at: session id put: session.
	^ session! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:29'!
processRequestForSession: aRequest 
	"PRIVATE: process aRequest and put a Session (new or old) in aRequest"
	| session newSessionID |
	mutex
		critical: [
			self checkForCleanup.
			session _ self currentSession: aRequest.
			newSessionID _ session isNil
						ifTrue: [
							session _ self newSession.
							session id].
			aRequest session: session.
			session timestamp: Time totalSeconds]
		ifError: [:msg :rcvr | rcvr error: msg].
	^ newSessionID! !


!HttpSessionModule class methodsFor: 'instance creation' stamp: 'DGD 7/24/2001 21:03'!
module: aModule 
	^ self new initializeModule: aModule! !

!HttpSessionModule class methodsFor: 'instance creation' stamp: 'DGD 7/24/2001 00:56'!
new
^ super new initialize! !


!HttpUnauthorized methodsFor: 'as yet unclassified' stamp: 'bolot 3/31/2001 15:41'!
asHttpResponseTo: request

	^(HttpResponse status: #unauthorized description: 'Unauthorized for: ', realm)
		fieldAt: 'WWW-Authenticate' put: 'Basic realm="', realm, '"';
		yourself! !

!HttpUnauthorized methodsFor: 'as yet unclassified' stamp: 'bolot 12/16/2000 02:27'!
signalRealm: aString

	realm _ aString.
	self signal.! !


!HttpUnauthorized class methodsFor: 'as yet unclassified' stamp: 'bolot 12/16/2000 02:28'!
for: realm
	^self new signalRealm: realm! !


!Kom5Preferences class methodsFor: 'preferences' stamp: 'bolot 2/20/2002 13:28'!
acceptTimeout
	^10 "seconds"! !

!Kom5Preferences class methodsFor: 'preferences' stamp: 'bolot 2/20/2002 13:28'!
acceptTimeoutDeadline
	^Socket deadlineSecs: self acceptTimeout! !

!Kom5Preferences class methodsFor: 'preferences' stamp: 'bolot 2/20/2002 13:28'!
backlogSize
	^self defaultBacklogSize! !

!Kom5Preferences class methodsFor: 'preferences' stamp: 'bolot 2/20/2002 13:28'!
defaultBacklogSize
	^10! !

!Kom5Preferences class methodsFor: 'preferences' stamp: 'bolot 2/20/2002 13:36'!
defaultResponseChunkSize
	"how many bytes to respond at a time"
	^ 131072! !

!Kom5Preferences class methodsFor: 'preferences' stamp: 'bolot 2/20/2002 13:28'!
listenerDestroyDelay
	^100 "milliseconds"! !


!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
form
	^form! !

!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
form: aForm
	form _ aForm! !

!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:49'!
name
	^name! !

!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:49'!
name: aName
	name _ aName! !


!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
collection
	^collection! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
collection: aCollection
	collection _ aCollection! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:38'!
defaultSelection
	^defaultSelection! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:38'!
defaultSelection: anObject
	defaultSelection _ anObject! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:51'!
sspStreamOn: strm
	strm nextPutAll: '<select>';
		cr.

	collection associationsDo: [:assoc |
		strm nextPutAll: '<option value="';
			nextPutAll: assoc key asString encodeForHTTP;
			nextPutAll: '">';
			nextPutAll: assoc value asString encodeForHTTP;
			nextPutAll: '</option>';
			cr].

	strm nextPutAll: '</select>';
		cr
! !


!KomHtmlSelectionList class methodsFor: 'instance creation' stamp: 'bolot 6/20/2001 22:42'!
newFrom: anObject
	(anObject isKindOf: Dictionary)
		ifTrue: [^self new collection: anObject].
	(anObject isKindOf: SequenceableCollection)
		ifTrue: [^self new collection: ((1 to: anObject size) collect: [:i | i -> (anObject at: i)])].
	(anObject isKindOf: Collection)
		ifTrue: [^self new collection: (anObject collect: [:obj | obj -> obj])].

	^self new collection: {anObject}! !


!LTDComancheServer methodsFor: 'initialize-release' stamp: 'bolot 2/5/2001 19:27'!
limitConnectionsTo: anInteger
	"limit to anInteger number of connections"
	maxThreads := anInteger! !

!LTDComancheServer methodsFor: 'private' stamp: 'bolot 2/5/2001 19:29'!
value: aSocket
	"handle a new connection"
	ltdSema wait.
	[
		[ self serviceProvider serve: aSocket  ]
			ensure:
		[ ltdSema signal ].
	] fork! !

!LTDComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 2/5/2001 19:45'!
start
	self register.
	Socket initializeNetwork.
	maxThreads ifNotNil: [ 
		ltdSema := Semaphore new.
		maxThreads timesRepeat: [ ltdSema signal ] ].
	self connectionHandler start! !


!LTDComancheService class methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:50'!
defaultServerClass
	^LTDComancheServer! !


!MIMEDocument methodsFor: 'access' stamp: 'svp 12/16/1999 11:55'!
mimeType

	^self type! !


!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 1/11/2001 18:35'!
defaultMIMEdatabase
	| d |
	(d _ Dictionary new)
	at: 'html' put: 'text/html';
	at: 'htm' put: 'text/html';
	at: 'xml' put: 'text/xml';
	at: 'txt' put: 'text/plain';
	at: 'c' put: 'text/plain';
	at: 'gif' put: 'image/gif';
	at: 'jpg' put: 'image/jpeg';
	at: 'jpeg' put: 'image/jpeg';
	at: 'png' put: 'image/png';
	at: 'xbm' put: 'image/x-xbitmap';
	at: 'mid' put: 'audio/midi';
	at: 'doc' put: 'application/ms-word-document'.
	^d! !

!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 6/22/2001 02:28'!
extendedMIMEdatabase
	| d |
	(d _ self defaultMIMEdatabase)
	at: 'sts' put: 'application/x-squeak-source';
	at: 'pr' put: 'application/x-squeak-project';
	at: 'hqx' put: 'application/mac-binhex40';
	at: 'doc' put: 'application/msword';
	at: 'xls' put: 'application/x-excel';
	at: 'ppt' put: 'application/mspowerpoint';
	at: 'ppz' put: 'application/mspowerpoint';
	at: 'pot' put: 'application/mspowerpoint';
	at: 'pps' put: 'application/mspowerpoint';
	at: 'cpt' put: 'application/mac-compactpro';
	at: 'pdf' put: 'application/pdf';
	at: 'ps' put: 'application/postscript';
	at: 'ai' put: 'application/postscript';
	at: 'eps' put: 'application/postscript';
	at: 'rtf' put: 'text/rtf';
	at: 'bin' put: 'application/octet-stream';
	at: 'dms' put: 'application/octet-stream';
	at: 'lha' put: 'application/octet-stream';
	at: 'lzh' put: 'application/octet-stream';
	at: 'exe' put: 'application/octet-stream';
	at: 'class' put: 'application/octet-stream';
	at: 'zip' put: 'application/zip';
	at: 'gtar' put: 'application/x-gtar';
	at: 'swf' put: 'application/x-shockwave-flash';
	at: 'sit' put: 'application/x-stuffit';
	at: 'tar' put: 'application/x-tar';
	at: 'au' put: 'audio/basic';
	at: 'snd' put: 'audio/basic';
	at: 'mid' put: 'audio/midi';
	at: 'midi' put: 'audio/midi';
	at: 'mpga' put: 'audio/mpeg';
	at: 'mp2' put: 'audio/mpeg';
	at: 'mp3' put: 'audio/mpeg';
	at: 'aiff' put: 'audio/x-aiff';
	at: 'aif' put: 'audio/x-aiff';
	at: 'aifc' put: 'audio/x-aiff';
	at: 'rm' put: 'audio/x-pn-realaudio';
	at: 'ram' put: 'audio/x-pn-realaudio';
	at: 'rpm' put: 'audio/x-pn-realaudio-plugin';
	at: 'ra' put: 'audio/x-realaudio';
	at: 'wav' put: 'audio/x-wav';
	at: 'css' put: 'text/css';
	at: 'mpeg' put: 'video/mpeg';
	at: 'mpg' put: 'video/mpeg';
	at: 'mpe' put: 'video/mpeg';
	at: 'qt' put: 'video/quicktime';
	at: 'mov' put: 'video/quicktime';
	at: 'avi' put: 'video/x-msvideo';
	at: 'movie' put: 'video/x-sgi-movie'.
	^d! !

!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 12/19/2000 00:53'!
initialize
	"MIMEDocument initialize"

	self resetMIMEdatabase! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'svp 12/16/1999 10:35'!
contentTypeGif
	^'image/gif'! !


!Morph methodsFor: 'debug and other' stamp: 'bolot 2/20/2002 12:56'!
buildDebugMenu: aHand
	"Answer a debugging menu for the receiver.  The hand argument is seemingly historical and plays no role presently"

	| aMenu aPlayer |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	(self hasProperty: #errorOnDraw) ifTrue:
		[aMenu add: 'start drawing again' action: #resumeAfterDrawError.
		aMenu addLine].
	(self hasProperty: #errorOnStep) ifTrue:
		[aMenu add: 'start stepping again' action: #resumeAfterStepError.
		aMenu addLine].

	aMenu add: 'inspect morph' action: #inspectInMorphic:.
	aMenu add: 'inspect owner chain' action: #inspectOwnerChain.
	Smalltalk isMorphic ifFalse:
		[aMenu add: 'inspect morph (in MVC)' action: #inspect].

	(self isKindOf: MorphicModel) ifTrue:
		[aMenu add: 'inspect model' target: self model action: #inspect].
	(aPlayer _ self player) ifNotNil:
		[aMenu add: 'inspect player' target: aPlayer action: #inspect].

     aMenu add: 'explore morph' target: self selector: #explore.

	aMenu addLine.
	aMenu add: 'viewer for Player' target: self player action: #beViewed.
	aMenu balloonTextForLastItem: 'Opens a viewer on my Player -- this is the same thing you get if you click on the cyan "View" halo handle'.
	aMenu add: 'viewer for Morph' target: self action: #viewMorphDirectly.
	aMenu balloonTextForLastItem: 'Opens a Viewer on this Morph, rather than on its Player'.
	aMenu addLine.

	aPlayer ifNotNil:
		[aPlayer class isUniClass ifTrue: [
			aMenu add: 'browse player class' target: aPlayer action: #browseHierarchy]].
	aMenu add: 'browse morph class' target: self selector: #browseHierarchy.
	aMenu addLine.

	aPlayer ifNotNil:
		[aMenu add: 'player protocol (tiles)' target: aPlayer action: #openInstanceBrowserWithTiles
			"#browseProtocolForPlayer"].
	aMenu add: 'morph protocol (text)' target: self selector: #haveFullProtocolBrowsed.
	aMenu add: 'morph protocol (tiles)' target: self selector: #openInstanceBrowserWithTiles.
	aMenu addLine.

	self addViewingItemsTo: aMenu.
	aMenu 
		add: 'make own subclass' action: #subclassMorph;
		add: 'internal name ' action: #choosePartName;
		add: 'save morph in file'  action: #saveOnFile;
		addLine;
		add: 'call #tempCommand' action: #tempCommand;
		add: 'define #tempCommand' action: #defineTempCommand;
		addLine;

		add: 'control-menu...' target: self selector: #invokeMetaMenu:;
		add: 'edit balloon help' action: #editBalloonHelpText.

	aMenu add: 'add to Comanche' action: #makeAvailableInComanche.

	^ aMenu! !

!Morph methodsFor: 'comanche' stamp: 'bolot 10/16/2001 21:33'!
asHttpResponseTo: request
	^self imageForm asHttpResponseTo: request! !


!MultipartChunk methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 02:38'!
initializeFrom: aDictionary
	| str fileName fieldName idx contentType |
	"PRE: all keys in aDictionary are low-case"
	header _ aDictionary.
	properties _ Dictionary new.
self flag: #todo.
	"parse the header, pick out: filename, etc."

	str _ (header at: 'content-disposition' ifAbsent: ['']).
	fileName _ fieldName _ ''.

	idx _ str findString: 'filename='.
	idx > 0 ifTrue:
		[fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].
	properties at: #fileName put: fileName.

	idx _ str findString: 'name='.
	idx > 0 ifTrue:
		[fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].
	properties at: #fieldName put: fieldName.

	contentType _ header at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
	properties at: #contentType put: contentType.

"Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
	show: 'content-type=', contentType; cr."
! !

!MultipartChunk methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 02:39'!
multipartBoundary: aString
	multipartBoundary _ aString! !

!MultipartChunk methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 02:39'!
request: aRequest
	request _ aRequest! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
contentType
	^properties at: #contentType! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
fieldName
	^properties at: #fieldName! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
fileName
	^properties at: #fileName! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
fileName: aString
	properties at: #fileName put: aString! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:38'!
multipartBoundary
	^multipartBoundary! !

!MultipartChunk methodsFor: 'accessing'!
saveToStream: outStream
	"Save this chunk's body in outStream"
	"the caller is responsible for closing outStream (if applicable)"
	| body origFileName idx str crlfBoundary |

	self setSavedFlag.

	origFileName _ self fileName.
	crlfBoundary _ String crlf , multipartBoundary.

	body _ request stream nextChunk.
	"IE4 for Mac appends 128 bytes of Mac file system info - must remove"
	"this fix assumes that body size >= 128"
	((body at: 1) asciiValue = 0
			and: [(body at: 2) asciiValue = origFileName size
				and: [(body copyFrom: 3 to: origFileName size + 2) = origFileName]])
		ifTrue: [body _ body copyFrom: 129 to: body size].
	[(idx _ body findString: crlfBoundary) = 0]
		whileTrue:
			[idx _ body size - crlfBoundary size + 1 max: 1.
			str _ request stream nextChunk.
			outStream nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	outStream nextPutAll: (body copyFrom: 1 to: idx-1).
"Transcript show: 'last few bytes: ', (body copyFrom: idx+2 to: body size); cr."
	request stream putDataBack: (body copyFrom: idx+2 to: body size). "idx+2 to skip CRLF"
! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:37'!
setSavedFlag
	properties at: #isSaved put: true! !

!MultipartChunk methodsFor: 'testing' stamp: 'bolot 12/16/2000 02:36'!
isSaved
	^(properties at: #isSaved ifAbsent: [false]) == true! !


!MultipartChunk class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 02:41'!
from: aDictionary
	aDictionary isEmptyOrNil
		ifTrue: [^nil].
	^self new initializeFrom: aDictionary! !


!NetworkProtocolAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 00:42'!
beginConversation
	"Process the stream, converting protocol requests into messages, and
		answers into protocol responses"

	self subclassResponsibility! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
log

	^log
! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
log: aLog

	log _ aLog
! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
readStream

	^readStream! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
target

	^target! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
writeStream

	^writeStream! !

!NetworkProtocolAdaptor methodsFor: 'dispatching' stamp: 'bolot 12/16/2000 00:43'!
dispatchRequest: aNetworkRequest
	"<Stream> Dispatches a NetworkRequest as a method to the target and
	answers a stream to be transferred to the client in the response"

	^self target processNetworkRequest: aNetworkRequest
! !

!NetworkProtocolAdaptor methodsFor: 'initialize-release' stamp: 'bolot 12/18/2000 22:45'!
initializeReadFrom: rStream writeTo: wStream target: aTarget
	readStream _ rStream.
	writeStream _ wStream.
	target _ aTarget! !


!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 5/11/2001 13:46'!
beginConversation
	startTime _ Time millisecondClockValue.
	[
		[(self pvtReadRequest) ifNotNil:
			[self pvtGetResponseAndDo:
				[self pvtWriteResponse.
				self pvtDestroyGently.
				"self pvtWriteLogAndDestroy"]
			].
		self isPersistentConnection and: [Preferences keepAliveConnections]] whileTrue.
		self pvtDestroy
	] on: Error do: [ :ex |
		(Preferences standaloneServer) ifTrue:
			[self pvtDestroy.
			self pvtHandleError: ex]
		ifFalse: "re-raise the exception"
			[ex signal].
	]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 4/12/2001 19:48'!
isPersistentConnection
	^request ifNotNil: [request isPersistentConnection] ifNil: [false]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/18/2000 23:19'!
pvtDestroy
	[
		self readStream close.
		self writeStream close.
		response ~~ nil ifTrue: [ response destroy ].
		readStream _ writeStream _ target _ response _ nil.
	]
	ifError: [:err :rcvr | "ignore"]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 2/11/2001 01:29'!
pvtDestroyGently
	"for persistent connections, only destroy response"
	[
		response ~~ nil ifTrue: [ response destroy ].
		response _ nil.
	]
	ifError: [:err :rcvr | "ignore"]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 3/31/2001 17:52'!
pvtGetResponseAndDo: blk
	[
		response _ ((self dispatchRequest: request) asHttpResponseTo: request)
			request: request;
			yourself.
	] on: Error do: [ :ex |
self flag: #todo. "figure out how to handle this error"
"ex signal."
"'error in HttpAdaptor>>pvtGetResponseAndDo:' displayAt: 10@160."

		response _ (ex asHttpResponseTo: request)
			request: request;
			yourself.
		blk value.
		self pvtHandleError: ex.
		^self
	].

	blk value! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 08:46'!
pvtHandleError: ex
	"place holder"! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 08:48'!
pvtLogActivity
	"place holder"! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 09:03'!
pvtReadRequest

	request _ HttpRequest readFromStream: self readStream.
	"Processor activeProcess contextAt: #request put: request"
	^request! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 08:48'!
pvtWriteLogAndDestroy
	self pvtWriteResponse.
	self pvtLogActivity.
	self pvtDestroy! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 7/4/2001 18:52'!
pvtWriteResponse
	[
		(self isPersistentConnection and: [Preferences keepAliveConnections])
			ifTrue: [response fieldAt: 'Connection' put: 'close']
			ifFalse: [response fieldAt: 'Connection' put: 'Keep-Alive'].
		response writeOn: self writeStream
	]
	on: Error do: [ :ex | 
		"If we're here, it's likely because something on the other
		end of the socket it hosed.  Do nothing, a log entry will 
		be written and the socket and response will be destroyed"
	]! !


!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'bolot 12/19/2000 00:26'!
readAndWriteTo: aStream target: aTarget
	^self new
		initializeReadFrom: aStream writeTo: aStream target: aTarget;
		beginConversation;
		yourself! !


!NetworkRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:35'!
method

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'accessing' stamp: 'DGD 7/24/2001 01:24'!
session
	^ session! !

!NetworkRequest methodsFor: 'accessing' stamp: 'DGD 7/24/2001 01:24'!
session: aSession
session _ aSession! !

!NetworkRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:36'!
url

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 00:36'!
initialize

	properties _ IdentityDictionary new.! !

!NetworkRequest methodsFor: 'testing' stamp: 'bolot 12/16/2000 00:37'!
isGetRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'testing' stamp: 'bolot 12/16/2000 00:37'!
isHeaderRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'testing' stamp: 'bolot 12/16/2000 00:37'!
isPostRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol

	^properties at: aSymbol! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol ifAbsent: absentBlock

	^properties at: aSymbol ifAbsent: absentBlock! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol ifAbsentPut: absentBlock

	^properties at: aSymbol ifAbsentPut: absentBlock! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol put: anObject

	properties at: aSymbol put: anObject! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
removePropertyAt: aSymbol

	properties removeKey: aSymbol! !


!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:04'!
destroy
	stream close.
	stream _ nil! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:01'!
initRemoteAddress
	(stream respondsTo: #remoteAddress) ifTrue: [
		self remoteAddress: stream remoteAddress.
	]! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 2/20/2002 13:51'!
initStatusString: aString
	| statusLine |
	statusLine _ aString findTokens: ' '.
	(statusLine size = 3 or: [statusLine = 2])
		ifTrue: [self method: statusLine first.
			rawUrl _ statusLine second.
			url _ rawUrl copyUpTo: $?.
			self queryString: (rawUrl copyFrom: (url size + 2) to: rawUrl size).
			"self protocol: statusLine third"]
		ifFalse: [^nil]! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 6/22/2001 13:18'!
initializeFromStream: aStream
	stream _ aStream.
	self initRemoteAddress.
	self timestamp: Time totalSeconds.
	[(self readRequestHeaderFrom: stream)
		ifNil: [^nil]
	] ifError: [:err :rcvr | ^nil]! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 5/14/2001 00:54'!
readRequestHeaderFrom: aStream
	| reqHeader |

	(reqHeader _ [aStream upToAll: self endOfRequestHeaderMarker]
			ifError: [:err :rcvr | ''])
		isEmpty ifTrue: [^nil].
	aStream match: self endOfRequestHeaderMarker.

	reqHeader _ BufferStream on: reqHeader.
	(self initStatusString: (reqHeader upToAll: String crlf))
		ifNil: [^nil].
	reqHeader match: String crlf.

	self header: (HttpParser parseHttpHeader: reqHeader upToEnd).
	self propertyAt: #headerBytes put: stream inBytes.

	self postFields. "force reading/parsing post fields"! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:03'!
contentLength

	^self propertyAt: #contentLength ifAbsentPut: [
		(header at: 'content-length' ifAbsent: [0]) asNumber
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:49'!
contentType
	| i contentType |
	^self propertyAt: #contentType ifAbsentPut: [
		contentType _ self header at: 'content-type' ifAbsent: [self defaultContentType].
		contentType ifNotNil: [i _ contentType indexOf: $;. "get rid of charset field"
			i > 0 ifTrue: [contentType _ contentType copyFrom: 1 to: i-1]].
		contentType asLowercase]! !

!HttpRequest methodsFor: 'accessing' stamp: 'DGD 7/22/2001 23:41'!
cookies
	"answer a dictionary with the cookies in the request"
	^ self
		propertyAt: #cookies
		ifAbsentPut: [self
				parseCookies: (self header
						at: 'cookie'
						ifAbsent: [''])]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:08'!
endOfRequestHeaderMarker
	^self class endOfRequestHeaderMarker! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/24/2000 15:45'!
getFields
	"retrieve fields encoded in the URL: http://aha/ha?a=1&b=2"
	| in |
	^self propertyAt: #getFields ifAbsentPut: [
		((in _ rawUrl indexOf: $?) > 0) ifTrue: [
			HttpParser decodeUrlEncodedForm: 
				(rawUrl copyFrom: (in + 1) to: rawUrl size)
		] ifFalse: [
			Dictionary new.
		].
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:13'!
header
	^header! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 09:18'!
header: aDict
	header _ aDict! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 2/11/2001 01:23'!
host
	^self propertyAt: #host ifAbsentPut: [self header at: 'host' ifAbsent: []]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:14'!
localAddress
	"Answer the address of the request originator"
	^self propertyAt: #localAddress ifAbsentPut: [
		(stream respondsTo: #localAddress) ifTrue: [
			stream localAddress
		] ifFalse: [
			nil
		]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:14'!
localPort
	"Answer the address of the request originator"
	^self propertyAt: #localPort ifAbsentPut: [
		(stream respondsTo: #localPort) ifTrue: [
			stream localPort
		] ifFalse: [
			nil
		]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:14'!
method
	^self propertyAt: #method ifAbsent: ['GET']! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/19/2000 00:16'!
method: aString
	self propertyAt: #method put: aString! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 09:40'!
postFields
	"Answer the multipart fields for a post request (if in fact this is a
	POST request"

	^self propertyAt: #postFields ifAbsentPut: [
		" parse POST fields in the body of request, if it's standard form data "

		(self isPostRequest and: [ 
			self contentType = MIMEDocument contentTypeFormData 
		]) ifTrue: [
			HttpParser decodeUrlEncodedForm: 
				(stream next: self contentLength).
		] ifFalse: [
			Dictionary new
		].
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:57'!
protocol
	^self propertyAt: #protocol ifAbsent: [self defaultProtocol]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 2/20/2002 13:51'!
queryString

	^self propertyAt: #queryString ifAbsent: [ nil ]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 2/20/2002 13:51'!
queryString: aString

	^self propertyAt: #queryString put: aString! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:58'!
rawUrl
	^rawUrl! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:57'!
referer
	^self propertyAt: #referer ifAbsentPut: [
		header at: 'referer' ifAbsent: [ nil ]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:57'!
remoteAddress
	^self propertyAt: #remoteAddress ifAbsent: [nil]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 09:18'!
remoteAddress: aRemoteAddress
	self propertyAt: #remoteAddress put: aRemoteAddress! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:59'!
stream
	^stream! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:00'!
timestamp

	^self propertyAt: #timestamp ifAbsent: [ nil ]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:00'!
timestamp: aTimestamp

	self propertyAt: #timestamp put: aTimestamp! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:58'!
url
	^url! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 6/21/2001 04:03'!
url: aUrl
	url _ aUrl! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:23'!
user
	"currently, only basic authentication is supported"
	| userID i |
	userID _ self header at: 'authorization' ifAbsent: [^nil].
	(userID notNil and: [(i _ userID findString: 'Basic ') > 0])
		ifTrue: [userID _ userID copyFrom: i+6 to: userID size]
		ifFalse: [userID _ nil].
	^userID! !

!HttpRequest methodsFor: 'multipart forms' stamp: 'bolot 1/11/2001 15:05'!
multipartBoundary
	| str idx |
	"boundary specification in the HTTP header looks like:
	Content-Type: multipart/form-data; boundary=BOUNDARY "

	^self propertyAt: #multipartBoundary ifAbsentPut: [
		(self contentType beginsWith: MIMEDocument contentTypeMultipart)
			ifTrue: ["contentType gets lowercased, so access the raw header"
				str _ header at: 'content-type' ifAbsent: [ '' ].
				idx _ str indexOf: $=.
				'--', (str copyFrom: idx + 1 to: str size)]
			ifFalse: [ nil ]]! !

!HttpRequest methodsFor: 'multipart forms' stamp: 'bolot 12/16/2000 02:39'!
multipartFormFieldsDo: aBlock
	"USAGE:
	request multipartFormFieldsDo: [:chunk |
		chunk saveToStream: aStream]."
	"NOTE: if the chunk is not saved, save it after aBlock"

	| mChunk aFieldValue |
	(self method = 'POST' and: [self contentType = MIMEDocument contentTypeMultipart])
		ifFalse: [^nil].

	[stream match: self multipartBoundary.
	stream match: '--']
	whileFalse:
	[
	stream match: String crlf.

	mChunk _ self nextChunkHeader.
	aBlock value: mChunk.
	mChunk flag: #todo. "review chunk saving logic"
	mChunk isSaved
		ifFalse: [
			mChunk fileName isEmptyOrNil
				ifFalse: [mChunk saveToStream: (DummyStream on: String new)]
				ifTrue: [
					aFieldValue _ String streamContents: [:aStream |
						mChunk saveToStream: aStream].
					self postFields at: mChunk fieldName put: aFieldValue
				]
		].

	]! !

!HttpRequest methodsFor: 'multipart forms' stamp: 'bolot 12/16/2000 03:05'!
nextChunkHeader
	"Read the next multipart data chunk's header"

	| string dict mChunk |
	string _ stream upToAll: self endOfRequestHeaderMarker.
	stream match: self endOfRequestHeaderMarker.

	dict _ HttpParser parseHttpHeader: string.
	mChunk _ MultipartChunk from: dict.
	mChunk request: self.
	mChunk multipartBoundary: self multipartBoundary.
	^mChunk! !

!HttpRequest methodsFor: 'printing' stamp: 'bolot 12/16/2000 02:09'!
printOn: printStream
	printStream nextPutAll: self class name;
		nextPutAll: ' (URL=', self url asString;
		nextPutAll: '; protocol=', self protocol asString;
		nextPutAll: '; header=', self header asString;
		nextPutAll: '; getFields=', self getFields asString;
		nextPutAll: '; postFields=', self postFields asString;
		nextPutAll: ')'! !

!HttpRequest methodsFor: 'printing' stamp: 'bolot 12/16/2000 02:09'!
writeOn: aStream
	"this can be used to form a client-side request and send it over network"
	aStream nextPutAll: self method, ' ', self url, ' ', self protocol, String crlf.
	self header keysAndValuesDo: [:key :value |
		aStream nextPutAll: key, ': ', value, String crlf].
	aStream nextPutAll: String crlf.
	aStream nextPutAll: self body asString! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 12/16/2000 02:27'!
badRequest
	^HttpBadRequest signal! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 12/16/2000 02:26'!
redirectTo: aUrl
	^HttpRedirect new signalLocation: aUrl! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 12/16/2000 02:28'!
unauthorizedFor: realm
	^HttpUnauthorized new signalRealm: realm! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:40'!
defaultContentType

	^self class defaultContentType! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:52'!
defaultMethod

	^self class defaultMethod! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:52'!
defaultProtocol

	^self class defaultProtocol! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:40'!
defaultUrl

	^self class defaultUrl! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isGetRequest

	^self method = 'GET'! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isHeaderRequest

	^self method = 'HEAD'! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isPostRequest

	^self method = 'POST'! !

!HttpRequest methodsFor: 'connection mgt' stamp: 'bolot 2/11/2001 01:21'!
isPersistentConnection
	| connectionHeader |
	^self propertyAt: #persistentConnection ifAbsentPut:
		[connectionHeader _ self header at: 'connection' ifAbsent: [nil].
		connectionHeader
			ifNil: [false]
			ifNotNil: [connectionHeader asLowercase = 'keep-alive']
		]! !

!HttpRequest methodsFor: 'private' stamp: 'DGD 7/22/2001 23:41'!
parseCookies: aString 
	"PRIVATE: Parse a string in the format:  
	Cookie: NAME1=OPAQUE_STRING1; NAME2=OPAQUE_STRING2 ..."
	| dict |
	dict _ Dictionary new.
	(aString findTokens: ';')
		collect: [:pairStr | 
			| pair | 
			pair _ pairStr findTokens: '='.
			pair size = 2
				ifTrue: [| key value | 
					key _ pair first withBlanksTrimmed asSymbol.
					value _ pair second withBlanksTrimmed.
					dict at: key put: value]
				ifFalse: [self log: 'Cookie invalid pair format: ''' , pairStr , '''']].
	^ dict! !

!HttpRequest methodsFor: 'user authentication' stamp: 'bolot 2/18/2002 19:21'!
userObject
	^self session ifNotNil: [self session userObject]! !

!HttpRequest methodsFor: 'user authentication' stamp: 'bolot 2/18/2002 19:24'!
userObject: anObject
	^self session ifNotNil: [self session userObject: anObject]! !


!NetworkRequest class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 00:42'!
new

	^super new initialize! !


!HttpRequest class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 03:08'!
readFromStream: aStream

	^self new initializeFromStream: aStream! !

!HttpRequest class methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 09:35'!
initialize
	EndOfRequestHeaderMarker _ String crlf, String crlf! !

!HttpRequest class methodsFor: 'accessing' stamp: 'bolot 12/16/2000 03:23'!
endOfRequestHeaderMarker
	"This marks the end of an HTTP request (two consecutive CR-LFs)"

	^EndOfRequestHeaderMarker! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:39'!
defaultContentType

	^MIMEDocument defaultContentType! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:51'!
defaultMethod

	^'GET'! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:50'!
defaultProtocol

	^'HTTP/1.0'! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:51'!
defaultUrl

	^''! !


!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:21'!
at: url
	^self map at: url! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:21'!
at: url ifAbsent: aBlock
	^self map at: url ifAbsent: aBlock! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:28'!
autoMap: obj
	| url |
	url _ '/comanche/objects/', self nextObjectID asString.
	self map: obj toUrl: url.
	^url! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:21'!
map
	^Map ifNil: [Map _ Dictionary new]! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:20'!
map: obj toUrl: url
	self map at: url put: obj! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:26'!
nextObjectID
	Index ifNil: [Index _ 0].
	^Index _ Index + 1! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:25'!
objList
	^String streamContents: [:strm |
		strm nextPutAll: '<html><head><title>Object URL Map List</title></head><body><table border="1">'.
		self map keysAndValuesDo: [:url :obj |
			strm nextPutAll: '<tr><td>', (url copyFrom: 19 to: url size), '</td><td><a href="',
				url asString, '">', obj asString, '</a></td></tr>', String crlf].
		strm nextPutAll: '</table></body></html>'.
	]! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:23'!
process: request
	| obj |
	obj _ self at: request url ifAbsent: [nil].
	request url = '/comanche/objects/list'
		ifTrue: [^self objList].
	^(obj respondsTo: #process:)
		ifTrue: [obj process: request]
		ifFalse: [obj]! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:23'!
urlForObject: obj
	^self map keyAtValue: obj! !

!ObjectUrlMap class methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:23'!
urlForObject: obj ifAbsent: aBlock
	^self map keyAtValue: obj ifAbsent: aBlock! !


!PWSComancheServer methodsFor: 'initialize-release' stamp: 'bolot 1/31/2001 23:56'!
initializeOnPort: aNumber priority: pNum serviceProvider: sp
	connectionHandler ifNotNil: [ connectionHandler destroy ].
	portNumber _ aNumber.
	priority _ pNum.
	serviceProvider _ sp! !

!PWSComancheServer methodsFor: 'initialize-release' stamp: 'bolot 1/31/2001 23:54'!
serverLoop
	"see PWS class>>loopOnPort:loggingTo:"

	| socket |
	[true] whileTrue: [
		socket _ connectionHandler getConnectionOrNil.
		socket notNil
			ifTrue: [self value: socket]
			ifFalse: [(Delay forMilliseconds: 100) wait]
	]! !

!PWSComancheServer methodsFor: 'accessing' stamp: 'bolot 1/31/2001 23:55'!
portNumber
	^portNumber! !

!PWSComancheServer methodsFor: 'accessing' stamp: 'bolot 1/31/2001 23:56'!
priority
	^priority! !

!PWSComancheServer methodsFor: 'accessing' stamp: 'bolot 1/31/2001 23:57'!
priority: aNum
	"do nothing"! !

!PWSComancheServer methodsFor: 'queries' stamp: 'bolot 1/31/2001 23:58'!
isRunning
	^self connectionHandler notNil! !

!PWSComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 2/1/2001 00:03'!
start
	self register.
	Socket initializeNetwork.
	connectionHandler _ ConnectionQueue portNumber: portNumber queueLength: 6.
	serverProcess _ [self serverLoop] newProcess.
	serverProcess priority: Processor lowIOPriority.
	serverProcess resume.! !

!PWSComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 2/1/2001 00:00'!
stop
	self connectionHandler ifNotNil: [self connectionHandler destroy].
	serverProcess ifNotNil: [serverProcess terminate].
	self unregister.
	connectionHandler _ serviceProvider _ nil! !


!PWSComancheService class methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:49'!
defaultServerClass
	^PWSComancheServer! !


!PartialResponseModule methodsFor: 'kom-processing' stamp: 'bolot 1/11/2001 18:02'!
process: request
	| response |
	response _ HttpPartialResponse fromString: ''.
	response producerBlock: [:aStream | self writeToStream: aStream] copy fixTemps.
	^response ! !

!PartialResponseModule methodsFor: 'kom-processing' stamp: 'bolot 1/11/2001 18:24'!
writeToStream: aStream
	aStream nextPutAll: 'aloha <BR>'.
	aStream nextPutAll: 'bloha <BR>'.! !


!Preferences class methodsFor: 'standard queries'!
keepAliveConnections
	^ self
		valueOfFlag: #keepAliveConnections
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries'!
standaloneServer
	^ self
		valueOfFlag: #standaloneServer
		ifAbsent: [true]! !

!Preferences class methodsFor: 'initial values' stamp: 'bolot 4/2/2001 16:17'!
initialValuesKomanche
	"initial values for Comanche"

	^ #(	
		(standaloneServer					true	(comanche))
		(keepAliveConnections				false	(comanche))
)
	"Preferences resetCategoryInfo"


! !

!Preferences class methodsFor: 'help' stamp: 'bolot 4/2/2001 16:16'!
helpMsgsKomanche
		^ #(

(standaloneServer
	'If true, then errors are suppressed.
If false, all errors are popped up')

(keepAliveConnections
	'Keep connections alive or terminate after each request')

		)! !


!SinglePageApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 18:49'!
asHtmlDocumentForRequest: request
	"todo: add input to the HTML doc"
	"todo: handle referencing images"
	self flag: #todo.

	^String streamContents: [:strm |
		strm nextPutAll: '<html>
			<head>
			<title>', self class name asString, '</title>
			</head>
			<body>'.
		output do: [:elem |
			strm nextPutAll: elem asHtmlElement;
				nextPutAll: ' '].
		strm nextPutAll: '<form method="get" action="';
			nextPutAll: self comancheUrl;
			nextPutAll: '">'.
		self inputFields do: [:elem |
			strm nextPutAll: (HtmlComancheForm formElementFromSpec: elem);
				nextPutAll: ' '].
		strm nextPutAll: '</form>
		</body>
		</html>'
	]! !

!SinglePageApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:18'!
getParameter: paramName from: request
	| spec type paramValue |
	spec _ self inputFields detect: [:elem | elem first = paramName] ifNone: [].
	spec ifNil: [^nil].
	paramValue _ request getFields at: paramName ifAbsent: [].
	type _ spec second.
	type == #SubmitButton
		ifTrue: [paramValue ifNil: [^false]. ^true].
	type == #Integer
		ifTrue: [paramValue ifNil: [^0]. ^paramValue asInteger].
	^nil! !

!SinglePageApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:34'!
initialize
	output _ OrderedCollection new.
	input _ OrderedCollection new.! !

!SinglePageApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/15/2001 16:48'!
inputFields
	^#()! !


!SinglePageTurtleApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:06'!
initialize
	super initialize.
	form _ Form extent: 300@300 depth: 8.
	pen _ Pen newOnForm: form.
	pen goto: form extent // 2.
	output add: form.! !

!SinglePageTurtleApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:06'!
inputFields
	^#((amount Integer)
		(forwardButton SubmitButton)
		(leftButton SubmitButton)
		(rightButton SubmitButton))! !

!SinglePageTurtleApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:35'!
process2: request
"	<comanche formFields: amount, forwardButton, leftButton, rightButton>

	forwardButton ifTrue: [pen go: amount].
	leftButton ifTrue: [pen turn: amount].
	rightButton ifTrue: [pen turn: amount negated]"! !

!SinglePageTurtleApp methodsFor: 'as yet unclassified' stamp: 'bolot 10/16/2001 21:19'!
process: request
	| amount forwardButton leftButton rightButton |
	"with Compiler support, the following lines will be invisible"
	amount _ self getParameter: 'amount' from: request.
	forwardButton _ self getParameter: 'forwardButton' from: request.
	leftButton _ self getParameter: 'leftButton' from: request.
	rightButton _ self getParameter: 'rightButton' from: request.

	forwardButton ifTrue: [pen go: amount].
	leftButton ifTrue: [pen turn: amount].
	rightButton ifTrue: [pen turn: amount negated]! !


!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 2/22/2001 18:47'!
processBlock: aBlock
	processBlock := aBlock! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:47'!
urlPattern
	^urlPattern ifNil: ['*']! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:45'!
urlPattern: aString
	urlPattern _ aString! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:43'!
urlPrefix: aString
	urlPattern _ aString, '*'! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:44'!
urlSuffix: aString
	urlPattern _ '*', aString! !

!SinglePlugModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 02:56'!
matchesUrl: aUrlString
	^self urlPattern match: aUrlString! !

!SinglePlugModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 02:46'!
process: request
	^(self matchesUrl: request url)
		ifTrue: [processBlock value: request]
		ifFalse: []! !


!SinglePlugModule class methodsFor: 'examples' stamp: 'bolot 5/1/2001 02:52'!
displayCam
	"SinglePlugModule displayCam"
	"this creates an equivalent of DisplayCamModule"
	| module |
	module _ self newBlock: [:request | Display magnifyBy: 1/8].
	module urlPrefix: '/desktopcam'.
	^module
! !

!SinglePlugModule class methodsFor: 'examples' stamp: 'bolot 5/1/2001 02:53'!
helloWorld
	"SinglePlugModule helloWorld"
	"this creates an equivalent of HelloWorldModule"
	| module |
	module _ self newBlock: [:request | 'Hello World!!'].
	module urlPrefix: '/helloworld'.
	^module
! !

!SinglePlugModule class methodsFor: 'examples' stamp: 'bolot 5/1/2001 02:54'!
redirectToDisplayCam
	"SinglePlugModule redirectToDisplayCam"
	| module |
	module _ self newBlock: [:request | request redirectTo: '/desktopcam'].
	module urlPrefix: '/desktopcamera'.
	^module
! !

!SinglePlugModule class methodsFor: 'instance creation' stamp: 'bolot 3/26/2001 21:55'!
newBlock: aBlock
	^self new processBlock: aBlock! !

!SinglePlugModule class methodsFor: 'instance creation' stamp: 'bolot 3/26/2001 21:55'!
newPlug: aBlock
	^self newBlock: aBlock! !


!Socket methodsFor: 'queries' stamp: 'bolot 10/21/1999 13:24'!
isOtherEndConnected
	| status |
	"Return true if this socket is connected or if the other end hasn't signalled a close yet."

	socketHandle == nil ifTrue: [^ false].
	status _ (self primSocketConnectionStatus: socketHandle).
	^(status = Connected or: [ status = ThisEndClosed ])! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 10/22/1999 11:29'!
discardReceivedData
	"Discard any data received up until now, and return the number of bytes discarded."

	| buf totalBytesDiscarded |
	buf _ String new: 10000.
	totalBytesDiscarded _ 0.
	[self isOtherEndConnected and: [ self dataAvailable ]] whileTrue: [
		totalBytesDiscarded _
			totalBytesDiscarded + (self receiveDataInto: buf)].
	^ totalBytesDiscarded
! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 12/18/2000 19:27'!
getData
	"Get some data"

	| buf bytesRead |
	(self waitForDataUntil: Socket standardDeadline) ifFalse: [self error: 'getData timeout'].
	buf _ String new: 4000.
	bytesRead _ self primSocket: socketHandle receiveDataInto: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: (bytesRead max: 0)! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 5/14/2001 00:59'!
getDataQuicker
	"Get some data, as getData, but with a shorter timeout"

	| buf bytesRead |
	(self waitForDataUntil: Socket quickDeadline) ifFalse: [self error: 'getData timeout'].
	buf _ String new: 4000.
	bytesRead _ self primSocket: socketHandle receiveDataInto: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: (bytesRead max: 0)! !

!Socket methodsFor: 'waiting' stamp: 'bolot 12/18/2000 19:30'!
waitForDisconnectionUntil: deadline
	"Wait up until the given deadline for the the connection to be broken. Return true if it is broken by the deadline, false if not."
	"Note: The client should know the the connect is really going to be closed (e.g., because he has called 'close' to send a close request to the other end) before calling this method.
JMM 00/5/17 note that other end can close which will terminate wait"

	| extraBytes status |
	extraBytes _ 0.
	status _ self primSocketConnectionStatus: socketHandle.
	[((status = Connected) or: [status = ThisEndClosed]) and:
	 [Time millisecondClockValue < deadline]] whileTrue: [
		self dataAvailable
			ifTrue: [extraBytes _ extraBytes + self discardReceivedData].
		semaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue).
		status _ self primSocketConnectionStatus: socketHandle].

	^ status ~= Connected
! !


!Socket class methodsFor: 'utilities' stamp: 'bolot 5/14/2001 00:59'!
quickDeadline
	^ self deadlineSecs: 10! !


!StaticFileModule methodsFor: 'kom processing' stamp: 'bolot 2/9/2001 19:51'!
folder
	^folder ifNil: [folder _ FileDirectory default directoryNamed: 'htdocs']! !

!StaticFileModule methodsFor: 'kom processing' stamp: 'bolot 2/9/2001 20:09'!
process: request
	| filePath |
	filePath _ (request url copyFrom: 2 to: request url size) translateWith: self slashXlat.
	^self folder fileNamed: filePath! !

!StaticFileModule methodsFor: 'kom processing' stamp: 'bolot 2/9/2001 20:09'!
slashXlat
	slashXlat ifNil: [slashXlat _ (0 to: 255) as: ByteArray].
	slashXlat at: ($/ asciiValue + 1) put: FileDirectory pathNameDelimiter asciiValue.
	^ slashXlat! !


!Stream methodsFor: 'accessing' stamp: 'SVP 8/26/1999 08:06'!
close

	"Do nothing by default"! !

!Stream methodsFor: 'accessing' stamp: 'SVP 8/12/1999 14:25'!
mimeType

	^MIMEDocument defaultContentType! !

!Stream methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromStream: self! !


!BufferStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:42'!
on: aString
	buffer _ aString.
	startPos _ 1.
	endPos _ buffer size! !

!BufferStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:42'!
reset
	"hack"
	self on: ''! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:36'!
contents
	"return contents, non-destructive"
	^buffer copyFrom: startPos to: endPos! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/19/2000 00:21'!
match: aString
	self size < aString size
		ifTrue: [^false].
	(self next: aString size) = aString
		ifTrue: [^true]
		ifFalse: [self on: aString, self upToEnd].
	^false! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:37'!
next
	"return the next character"
	"consume it"
	^buffer at: (startPos _ startPos + 1) - 1! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:37'!
next: anInteger
	"return next anInteger characters"
	"consumes them"
	^buffer copyFrom: startPos to: (startPos _ startPos + anInteger) - 1! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
nextPutAll: aString
	buffer _ (buffer copyFrom: startPos to: endPos), aString.
	startPos _ 1.
	endPos _ buffer size! !

!BufferStream methodsFor: 'accessing' stamp: 'gh 1/4/2002 12:57'!
peek
	"return the next character without consuming it"
	"consume it"
	^buffer at: startPos! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:43'!
size
	^endPos - startPos + 1! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
upTo: aChar
	"return String up to aChar, but not including"
	"consumes the returned string"
	| i |
	i _ buffer indexOf: aChar startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
upToAll: aString
	"return a string before the occurence of aString, if any"
	"consume it"
	| i |
	i _ buffer findString: aString startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
upToEnd
	"return buffer contents,
	consume all my buffer"
	| string |
	string _ self contents.
	self reset.
	^string! !

!BufferStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:37'!
includes: aChar
	"answer whether buffer includes aChar within bounds"
	| tmp |
	tmp _ buffer indexOf: aChar startingAt: startPos.
	^(tmp >= startPos) and: [tmp <= endPos]! !

!BufferStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:37'!
includesAll: aString
	"answer whether the buffer contains aString"
	| tmp |
	tmp _ buffer findString: aString startingAt: startPos.
	^(tmp >= startPos) and: [tmp <= endPos]! !

!BufferStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:37'!
isEmpty
	^self size <= 0! !

!BufferStream methodsFor: 'printing' stamp: 'bolot 12/16/2000 01:41'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self size asString, ')'! !


!BufferStream class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 01:44'!
on: aString
	^self basicNew on: aString! !


!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 2/5/2001 15:46'!
close
	self flush.
	self socket closeAndDestroy: 30! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:46'!
initialize
	self resetStatus.
	self setBuffered.
	self resetInStream.
	self resetOutStream! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:46'!
initialize: aSocket
	self initialize.
	self socket: aSocket! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:52'!
resetInStream
	inStream _ BufferStream on: ''! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:52'!
resetOutStream
	outStream _ BufferStream on: ''! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:53'!
resetStatus
	(status _ Dictionary new)
	at: #inDataCount put: 0;
	at: #outDataCount put: 0! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
localAddress
	^status at: #localAddress! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
localPort
	^status at: #localPort! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
remoteAddress
	^status at: #remoteAddress! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
remotePort
	^status at: #remotePort! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:50'!
setBuffered
	status at: #buffered put: true! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:50'!
setUnBuffered
	status at: #buffered put: false! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 2/5/2001 15:44'!
socket
	^socket! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 2/5/2001 15:40'!
socket: aSocket
	socket _ aSocket.
	status at: #localAddress put: aSocket localAddress.
	status at: #localPort put: aSocket localPort.
	status at: #remoteAddress put: aSocket remoteAddress.
	status at: #remotePort put: aSocket remotePort! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:51'!
status
	^status! !

!SocketStream methodsFor: 'stream in'!
match: aString
	"position past the next occurrence of aString"
	"bolot 12/13/2000 00:49 - must begin with it"
	"answer if aString is found"
	[inStream size < aString size
		ifTrue: [self flag: #todo. "should try to read in more, unless #atEnd"
			"but since atEnd is somewhat broken, don't use it yet"
			Transcript show: 'did not match ', aString; cr.
			^false]].

	self readToMakeBufferSize: aString size.

	(inStream contents beginsWith: aString)
		ifTrue: [inStream next: aString size.
			^true].

	^false! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:31'!
next
	self atEnd ifTrue: [^nil].
	inStream isEmpty ifTrue: [self pvtGetData].
	^inStream next! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:30'!
next: n
	| limit |

	[(inStream size < n) and: [ self isConnected ]]
		whileTrue: [self pvtGetData].

	limit _ n min: inStream size.
	^inStream next: limit! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/5/2000 15:59'!
nextChunk
	"getData front - retrieve all data available now"
	inStream isEmpty
		ifTrue: [self pvtGetData].
	^inStream upToEnd! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/7/2002 08:41'!
nextLine
	"Get the next line from the server.
	We use lf as line separator. A single preceding cr
	will be discarded in order to be compatible with
	clients sending crlfs instead of only lf."
	
	| nextLine |
	nextLine _ self upTo: Character lf.
	self next. "eat the lf"
	(nextLine size > 0 and: [nextLine last = Character cr])
		 ifTrue:[^nextLine allButLast].
	^nextLine! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/7/2002 13:20'!
nextLineCr
	"Get the next line from the server.
	We use cr as line separator. A single following lf
	will be discarded in order to be compatible with
	clients sending crlfs instead of only cr."
	
	| nextLine |
	nextLine _ self upTo: Character cr.
	self next. "eat the cr"
	(self peek = Character lf)
		 ifTrue:[self next].
	^nextLine! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/4/2002 12:57'!
peek
	self atEnd ifTrue: [^nil].
	inStream isEmpty ifTrue: [self pvtGetData].
	^inStream peek! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/22/1999 17:06'!
putDataBack: string
	| tempString |
	tempString _ inStream contents.
	self resetInStream.
	inStream nextPutAll: string; nextPutAll: tempString! !

!SocketStream methodsFor: 'stream in'!
readToMakeBufferSize: nBytes
	"keep reading the socket until we have nBytes in the buffer"
	"also, keep track of time-outs"

	[inStream size < nBytes]
		whileTrue: [self pvtGetData]! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:29'!
upTo: delim 
	| string |
	(inStream includes: delim)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upTo: delim].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			string _ inStream contents.
			self resetInStream.
			^string].
	"Never found it, but there's more..."
	self pvtGetData.
	^self upTo: delim! !

!SocketStream methodsFor: 'stream in' stamp: 'gh 1/10/2002 11:28'!
upToAll: delims

	[(inStream includesAll: delims)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upToAll: delims].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			^inStream upToEnd].
	"Did not find it, we fetch some more and try again..."
	self pvtGetData] repeat! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/22/1999 17:13'!
upToEnd
	| rest |
	rest _ socket getRestOfBuffer: inStream contents totalLength: self contentLength.
	self resetInStream.
	(rest isKindOf: String) ifTrue: [^'']. " error "
	^rest contents
! !

!SocketStream methodsFor: 'stream out' stamp: 'gh 1/4/2002 14:08'!
cr
	self nextPut: Character cr! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 8/11/1999 22:13'!
crlf
	self nextPutAll: String crlf! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 1/21/2000 16:33'!
flush
	socket isOtherEndConnected
		ifTrue: [socket sendData: outStream contents].
	self incOutDataCountBy: outStream contents size.
	self resetOutStream! !

!SocketStream methodsFor: 'stream out' stamp: 'gh 1/4/2002 14:08'!
lf
	self nextPut: Character lf! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:24'!
nextPut: char
	self nextPutAll: char asString! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:25'!
nextPutAll: string
	outStream nextPutAll: string.
	self isBuffered ifTrue: [self flush]! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:50'!
atEnd
	^self isConnected not
	and: [inStream isEmpty
	and: [self isDataAvailable not]]! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:50'!
isBuffered
	^true = (status at: #buffered ifAbsent: [false])! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 2/5/2001 15:47'!
isConnected
	^self socket isConnected! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 2/5/2001 15:47'!
isDataAvailable
	^self socket dataAvailable! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 2/5/2001 15:48'!
isOtherEndConnected
	^self socket isOtherEndConnected! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 03:03'!
inBytes "actual number of bytes read by the app"
	^self inDataCount - inStream size! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:51'!
inDataCount
	^status at: #inDataCount! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:52'!
incInDataCountBy: increment
	"increment inDataCount by"
	status at: #inDataCount modify: [:n | n + increment]! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:52'!
incOutDataCountBy: increment
	"increment outDataCount by"
	status at: #outDataCount modify: [:n | n + increment]! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:52'!
outDataCount
	^status at: #outDataCount! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 5/14/2001 01:00'!
pvtGetData
	| string |
	inStream nextPutAll: (string _ socket getDataQuicker).
	self incInDataCountBy: string size.
	^string! !


!SocketStream class methodsFor: 'instance creation' stamp: 'bolot 12/16/1999 18:06'!
on: socket
	"create a socket stream on a server socket"
	"for HTTP style header must call readHeader explicitly"
	^self basicNew initialize: socket! !


!String methodsFor: 'converting' stamp: 'bolot 2/5/2001 20:01'!
asHttpResponseTo: request

	^HttpResponse fromString: self! !


!Text methodsFor: 'converting' stamp: 'bolot 3/17/2001 22:55'!
asHtmlDocumentForRequest: request
	| readStream targetStream |

	readStream _ ReadStream on: (self string).
	targetStream _ WriteStream on: ''.
	targetStream nextPutAll: (HTMLformatter startPage: 'A page generated by Comanche').
	targetStream nextPutAll: '<PRE>'.
	(self runs values) with: (self runs runs) do:
		[:aValue :aRun |
			aValue do: [:attr | attr printHtmlOpenTagOn: targetStream].
			targetStream nextPutAll: (readStream next: aRun).
			aValue reverseDo: [:attr | attr printHtmlCloseTagOn: targetStream].
		].

	targetStream nextPutAll: '</PRE>'.
	targetStream nextPutAll: (HTMLformatter endPage).
	^targetStream contents! !


!TextAnchor methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:45'!
printHtmlOpenTagOn: strm
	"do nothing for now"
	"save the embedded image in a file to be served by Comanche"! !


!TextColor methodsFor: 'printing' stamp: 'bolot 3/17/2001 22:40'!
printHtmlCloseTagOn: strm
	strm
		nextPutAll: '</FONT>'! !

!TextColor methodsFor: 'printing' stamp: 'bolot 3/17/2001 22:53'!
printHtmlOpenTagOn: strm
	strm
		nextPutAll: '<FONT COLOR="#';
		nextPutAll: self color hex;
		nextPutAll: '">'! !


!TextEmphasis methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:39'!
printHtmlCloseTagOn: strm
	emphasisCode = 1 ifTrue: [strm nextPutAll: '</B>'].
	emphasisCode = 2 ifTrue: [strm nextPutAll: '</I>'].
	emphasisCode = 4 ifTrue: [strm nextPutAll: '</U>'].
	emphasisCode = 16 ifTrue: [strm nextPutAll: '</S>']! !

!TextEmphasis methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:39'!
printHtmlOpenTagOn: strm
	emphasisCode = 1 ifTrue: [strm nextPutAll: '<B>'].
	emphasisCode = 2 ifTrue: [strm nextPutAll: '<I>'].
	emphasisCode = 4 ifTrue: [strm nextPutAll: '<U>'].
	emphasisCode = 16 ifTrue: [strm nextPutAll: '<S>']! !


!TextFontChange methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlCloseTagOn: strm
	strm
		nextPutAll: '</FONT>'! !

!TextFontChange methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlOpenTagOn: strm
	strm
		nextPutAll: '<FONT SIZE="';
		nextPutAll: (self fontNumber + 2) asString;
		nextPutAll: '">'! !


!TextMorph methodsFor: 'comanche' stamp: 'bolot 10/16/2001 21:45'!
asHttpResponseTo: request
	^self asText asHttpResponseTo: request! !


!TextURL methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlCloseTagOn: strm
	strm
		nextPutAll: '</A>'! !

!TextURL methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlOpenTagOn: strm
	strm
		nextPutAll: '<A HREF="';
		nextPutAll: self info;
		nextPutAll: '">'! !


!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:36'!
fromString: aString
	"Answer a new instance for the value given by aString.

	 Time fromString: '11:55:23 am'
	"

	^self readFrom: (ReadStream on: aString)! !

!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:10'!
midnight
	"Answer a new instance at midnight."

	^self fromSeconds: 0! !

!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:09'!
noon
	"Answer a new instance at noon."

	^self fromSeconds: 43200! !


!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:51'!
date
	"Answer the date of the receiver."

	^date! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:52'!
date: aDate
	"Private - set the date of the receiver."

	date := aDate! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:53'!
time
	"Answer the time of the receiver."

	^time! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:54'!
time: aTime
	"Private - set the time of the receiver."

	time := aTime! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:00'!
minusDays: anInteger
	"Answer a TimeStamp which is anInteger days before the receiver."

	^self class date: (self date addDays: anInteger negated) time: self time! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:03'!
minusSeconds: anInteger
	"Answer a TimeStamp which is anInteger number of seconds before the receiver."

	^self class fromSeconds: ((self asSeconds) - anInteger)! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:00'!
plusDays: anInteger
	"Answer a TimeStamp which is anInteger days after the receiver."

	^self class date: (self date addDays: anInteger) time: self time! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:02'!
plusSeconds: anInteger
	"Answer a TimeStamp which is anInteger number of seconds after the receiver."

	^self class fromSeconds: ((self asSeconds) + anInteger)! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:22'!
< aTimeStamp
	"Answer true if the receiver is less than aTimeStamp, otherwise answer false."

	^self date < aTimeStamp date 
		or: [self date = aTimeStamp date and: [self time < aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:23'!
<= aTimeStamp
	"Answer true if the receiver is less than or equal to aTimeStamp, otherwise answer false."

	^self date < aTimeStamp date
		or: [self date = aTimeStamp date and: [self time <= aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:41'!
= aTimeStamp
	"ccn Note:  this does not take TimeZones into account.  Some day that should be fixed..."

	^self class = aTimeStamp class
		and: [self date = aTimeStamp date
		and: [self time = aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:23'!
> aTimeStamp
	"Answer true if the receiver is greater than aTimeStamp, otherwise answer false."

	^self date > aTimeStamp date
		or: [self date = aTimeStamp date and: [self time > aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:24'!
>= aTimeStamp
	"Answer true if the receiver is greater than or equal to aTimeStamp, otherwise answer false."

	^self date > aTimeStamp date
		or: [self date = aTimeStamp date and: [self time >= aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:06'!
hash
	"Answer the Integer hash value for the receiver."

	^self date hash bitXor: self time hash! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:04'!
asDate
	"Answer the receiver as an instance of Date."

	^self date! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:25'!
asSeconds
	"Return the number of seconds in the receiver."

	^(self date asSeconds + self time asSeconds)! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:04'!
asTime
	"Answer the receiver as an instance of Time."

	^self time! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:33'!
asTimeStamp
	"Answer the receiver as an instance of TimeStamp."

	^self! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:34'!
dateAndTime
	"Answer a two element Array containing the receiver's date and time."

	^Array with: self date with: self time! !

!TimeStamp methodsFor: 'printing' stamp: 'ccn 10/6/2000 23:51'!
printOn: aStream
	"Print receiver's date and time on aStream."

	| dateString timeString |
	dateString _ (self date isNil)
		ifTrue: ['no date']
		ifFalse: [self date printString].
	timeString _ (self time isNil)
		ifTrue: ['no time']
		ifFalse: [self time printString].
	(self date isNil and: [self time isNil])
		ifTrue:
			[super printOn: aStream.
			aStream nextPutAll: ' '].
	aStream 
		nextPutAll: dateString;
		nextPutAll: ', ';
		nextPutAll: timeString! !


!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/6/2000 22:59'!
current
	"Answer the current date and time as a TimeStamp."

	| array |
	array _ Time dateAndTimeNow.
	^self date: array first time: array last! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/6/2000 23:00'!
date: aDate time: aTime
	"Answer a new instance based on the given date and time."

	^self
		new date: aDate;
		time: aTime;
		yourself! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:07'!
fromSeconds: anInteger
	"Answer a new instance based on the given number of seconds."

	| date |
	date _ Date fromSeconds: anInteger.
	^self date: date time: (Time fromSeconds: (anInteger - date asSeconds))! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:36'!
fromString: aString
	"Answer a new instance for the value given by aString.

	 TimeStamp fromString: '1-10-2000 11:55:00 am'. 
	"

	| stream |
	stream := ReadStream on: aString withBlanksTrimmed.
	^self 
		date: (Date fromString: (stream upTo: $ )) 
		time: (Time fromString: (stream upTo: nil))! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:18'!
midnight
	"Answer a new instance that represents today at midnight."

	^self midnightOn: Date today! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:19'!
midnightOn: aDate
	"Answer a new instance that represents aDate at midnight."

	^self date: aDate time: Time midnight! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:16'!
noon
	"Answer a new instance that represents today at noon."

	^self noonOn: Date today! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:16'!
noonOn: aDate
	"Answer a new instance that represents aDate at noon."

	^self date: aDate time: Time noon! !


!TurtleGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 03:15'!
initialize
	form _ Form extent: 300@300 depth: 8.
	pen _ Pen newOnForm: form.
	pen goto: form extent // 2.
! !

!TurtleGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 03:13'!
process: request
	| operation amount |

	(self matchesUrl: request url)
		ifFalse: [^nil].

	(request url asLowercase endsWith: '.gif')
		ifTrue: [^form].

	operation _ request getFields at: 'operation' ifAbsent: [].
	amount _ request getFields at: 'amount' ifAbsent: [].

	(operation isNil or: [amount isNil])
		ifFalse: [amount _ amount asNumber.
			operation = 'forward' ifTrue: [pen go: amount].
			operation = 'left' ifTrue: [pen turn: amount].
			operation = 'right' ifTrue: [pen turn: amount negated]].

^'<HTML>
<HEAD><TITLE>Comanche Turtle</TITLE></HEAD>

<BODY>
<IMG SRC="', (self urlPattern copyReplaceAll: '*' with: '/turtle.gif'), '">
<FORM ACTION="', request url, '" METHOD="GET">
<INPUT TYPE="text" NAME="amount">
<INPUT TYPE="submit" NAME="operation" VALUE="forward">
<INPUT TYPE="submit" NAME="operation" VALUE="left">
<INPUT TYPE="submit" NAME="operation" VALUE="right">
</FORM>
</BODY>
</HTML>'! !


!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 18:56'!
commandConsoleForRequest: request
^'<HTML>
<HEAD><TITLE>Comanche Turtle</TITLE></HEAD>

<BODY>
<FORM ACTION="', (self urlPattern copyReplaceAll: '*' with: '/turtle.gif'), '" METHOD="GET" TARGET="turtleimageframe">
<INPUT TYPE="text" NAME="amount">
<INPUT TYPE="submit" NAME="operation" VALUE="forward">
<INPUT TYPE="submit" NAME="operation" VALUE="left">
<INPUT TYPE="submit" NAME="operation" VALUE="right">
</FORM>
</BODY>
</HTML>'! !

!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 18:57'!
imageForRequest: request
	| operation amount |

	operation _ request getFields at: 'operation' ifAbsent: [].
	amount _ request getFields at: 'amount' ifAbsent: [].

	(operation isNil or: [amount isNil])
		ifFalse: [amount _ amount asNumber.
			operation = 'forward' ifTrue: [pen go: amount].
			operation = 'left' ifTrue: [pen turn: amount].
			operation = 'right' ifTrue: [pen turn: amount negated]].

	^form! !

!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 19:02'!
process: request
	(self matchesUrl: request url)
		ifFalse: [^nil].

	(request url asLowercase endsWith: 'turtle.gif')
		ifTrue: [^self imageForRequest: request].

	(request url asLowercase endsWith: 'command.html')
		ifTrue: [^self commandConsoleForRequest: request].

	^self topFrameForRequest: request! !

!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 19:01'!
topFrameForRequest: request
^'<HTML>
<HEAD>
<TITLE>Turtle Graphics in Comanche, with Frames</TITLE>
</HEAD>
<FRAMESET ROWS="*,150">
<FRAME NAME="turtleimageframe" SRC="', (self urlPattern copyReplaceAll: '*' with: '/turtle.gif'), '">
<FRAME NAME="turtlecmd" SRC="', (self urlPattern copyReplaceAll: '*' with: '/command.html'), '">
</FRAMESET>
</HTML>'! !


!UndefinedObject methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:08'!
asHttpResponseTo: request

	^HttpResponse 
		status: #notFound 
		description: 'The object you requested was not found on this server.'! !


!WriteStream methodsFor: 'converting' stamp: 'bolot 1/3/2000 17:13'!
asHttpResponseTo: request

	^HttpResponse fromMIMEDocument: 
		(MIMEDocument contentType: self mimeType content: self contents)! !

!WriteStream methodsFor: 'as yet unclassified' stamp: 'SVP 8/24/1999 15:49'!
mimeType

	^'text/html'! !


!ReadWriteStream methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromStream: self! !


!StandardFileStream methodsFor: 'access' stamp: 'SVP 8/24/1999 15:47'!
mimeType

	^MIMEDocument guessTypeFromName: self name.
! !


!TurtleGraphicsModule reorganize!
('comanche' initialize process:)
!

HttpRequest initialize!
MIMEDocument initialize!
HttpSession initialize!
HttpResponse initialize!
ComancheService initialize!
ComancheServer initialize!
"Postscript:
Set preferences."
Preferences initializeHelpMessages.
Preferences initializeAddedPreferences.
Preferences addPreference: #standaloneServer category: #comanche default: true balloonHelp: 'If true, then errors are suppressed.
If false, all errors are popped up'.
Preferences addPreference: #keepAliveConnections category: #comanche default: false balloonHelp: 'Keep connections alive or terminate after each request'.!

